{	Tools Plus (Version 3.0) CodeWarrior Pascal interface																								}
{	Copyright (C) 1989-96 Waters Edge Software																											}

{	This unit is the interface between Pascal applications and Tools Plus.  It must be used by any program or unit		}
{	that makes reference to any part of Tools Plus.																											}
{																																														}
{	All TYPEs, VARiables, and CONSTants required by Tools Plus are included.															}


{$PUSH}
{$ALIGN MAC68K}

unit ToolsPlus;

interface
	uses
		Controls, Events;


	 const
																											{INITIALIZATION:												}
		initUseColor = $00000001;															{	Use Color QuickDraw if available					}
		initIgnoreColor = $00000000;														{	Don't use Color QuickDraw								}
		initUseTEScrap = $00000002;													{	Use TextEdit scrap											}
		initIgnoreTEScrap = $00000000;												{	Don't use TextEdit scrap									}
		initDontUnloadDeskScrap = $00000004;									{	Don't unload desk scrap									}
		initUnloadDeskScrap = $00000008;											{	Unload desk scrap to disk								}
		initTEStr255Buffer = 255;															{	TextEdit Undo buff:	255 chars						}
		initTE32KBuffer = 32767;															{						32K chars (max)							}

																											{POLLING:															}
		doNothing = 0;																				{	No event															}
		doChgWindow = 1;																		{	User clicked in an inactive window					}
		doRefresh = 2;																				{	A window has to be refreshed							}
		doGoAway = 3;																			{	The close box was clicked								}
		doButton = 4;																				{	Button was clicked											}
		doMenu = 5;																					{	Menu was selected											}
		doKeyDown = 6;																			{	A keyboard key was pressed							}
		doAutoKey = 7;																			{	A keyboard key is auto-repeating					}
		doKeyUp = 8;																				{	A keyboard key was released							}
		doClickField = 9;																			{	Mouse clicked in inactive field						}
		doScrollBar = 10;																			{	Mouse clicked in a scroll bar							}
		doListBox = 11;																			{	Some sort of List Box activity							}
		doClick = 12;																				{	Mouse click/drag												}
		doPopUpMenu = 13;																	{	Pop-up menu was selected								}
		doPictButton = 14;																		{	Picture button activity										}
		doClickControl = 101;																	{	Mouse clicked in a custom control					}
		doManualEvent = 102;																{	Manually processed events							}
		doMoveWindow = 103;																{	A window was moved by user							}
		doGrowWindow = 104;																	{	A window was re-sized by the user					}
		doClickDesk = 105;																		{	Mouse clicked in the desk top							}
		doZoomWindow = 106;																{	Zoom box was clicked by user						}
		doSuspend = 107;																		{	Appl. suspended (in background)					}
		doResume = 108;																		{	Appl. resumed (now active appl.)					}
		doChgInField = 109;																	{	Editing field contents was changed				}
		doPreRefresh = 110;																	{	Refresh window before T+ objects					}
		doActivate = 111;																		{	Window was activated										}
		doDeactivate = 112;																	{	Window was deactivated									}
		doMoveCursor = 113;																	{	Cursor has entered a new Cursor Zone			}
		inUpButton = 20;																			{	Scroll Bar parts:	Up button								}
		inDownButton = 21;																		{								Down button						}
		inPageUp = 22;																			{								Page Up area						}
		inPageDown = 23;																		{								Page Down area					}
		inThumb = 129;																			{								Thumb									}
		inClick1 = 1;																					{	Clicks:	Mouse single-click completed				}
		inClick2 = 2;																					{				Mouse double-click completed			}
		inClick3 = 3;																					{				Mouse triple-click completed				}
		inClick1Drag = -1;																		{				Mouse single-click, still dragging		}
		inClick2Drag = -2;																		{				Mouse double-click, still dragging		}
		inClick3Drag = -3;																		{				Mouse triple-click, still dragging			}
		EnterKey = char($03);																	{	Keys:	Key characters (ASCII) for common	}
		BackSpaceKey = char($08);														{				non apha-numeric keys.						}
		DeleteKey = BackSpaceKey;														{				In some cases, several keys				}
		TabKey = char($09);																	{				produce the same ASCII						}
		ReturnKey = char($0D);																{				character.  They can be						}
		EscClearKey = char($1B);															{  ($1B)		differentiated by using the key			}
		LeftArrowKey = char($1C);															{				code, as indicated below.					}
		RightArrowKey = char($1D);														{				Some keys are available only				}
		UpArrowKey = char($1E);															{				on an extended keyboard.					}
		DownArrowKey = char($1F);														{																			}
		HelpKey = char($05);																	{																			}
		HomeKey = char($01);																{																			}
		DeleteFwdKey = char($7F);															{																			}
		EndKey = char($04);																	{																			}
		PageUpKey = char($0B);															{																			}
		PageDownKey = char($0C);														{																			}
		FKey = char($10);																		{  ($10)		Function keys F1 to F15						}
		EscKeyCode = $35;																	{  ($1B)		KEY CODES used to differentiate		}
		ClearKeyCode = $47;																	{  ($1B)			between keys which produce			}
		F1KeyCode = $7A;																		{				the same key characters.					}
		F2KeyCode = $78;																		{																			}
		F3KeyCode = $63;																		{																			}
		F4KeyCode = $76;																		{																			}
		F5KeyCode = $60;																		{																			}
		F6KeyCode = $61;																		{																			}
		F7KeyCode = $62;																		{																			}
		F8KeyCode = $64;																		{																			}
		F9KeyCode = $65;																		{																			}
		F10KeyCode = $6D;																	{																			}
		F11KeyCode = $67;																		{																			}
		F12KeyCode = $6F;																		{																			}
		F13KeyCode = $69;																		{																			}
		F14KeyCode = $6B;																	{																			}
		F15KeyCode = $71;																		{																			}

																											{WINDOWS:														}
		GoAway = true;																			{	No "close box"													}
		NoGoAway = false;																		{	Window has a "close box"								}
		Modal = true;																				{	Window is modal												}
		NotModal = false;																		{	Window is modeless										}
		movableBoxProc = 5;																	{	Movable modal dialog ProcID							}
																											{	(add to the procID)										}
		ZoomBox = 8;																				{		Zoom box														}
		wCenter = $00010000;																{		Auto-centering											}
		wTile = $00020000;																		{		Auto-tiling													}
		wRefresh = $00040000;																{		Forced refresh												}
		wNoOffScreen = $00080000;														{		Prevent from being all off-screen				}
		wAllOnScreen = $00100000;														{		Entire window must be on screen				}
		wNoZoomLines = $01000000;														{		Suppress 'zoom lines' when zooming			}
		wHidden = $02000000;																{		Window is opened hidden							}
		wPalette = $80000000;																{		Palette behavior (add to procID)					}
		ordPaletteProc = 32000;																{		Window that looks like Palette					}
		paletteProc = wPalette + 32000;													{		T+s Floating Palette window						}
		altPaletteProc = wPalette + 32002;												{		T+s palette with drag bar on left					}
																											{	(add to modal win. procID, Sys 7+)				}
		wAllowEditMenu = $40000000;													{		Allow access to Edit menu only					}
		wAllowMenus = $20000000;														{		Allow access to all menus							}
		wDimEditMenu = $10000000;														{		Disable Edit menu's items							}
		wNoKind = 0;																				{Kinds of Windows:	Not open							}
		wToolBarKind = 1;																		{									Tool Bar							}
		wFloatingKind = 2;																		{									Floating Palette				}
		wStandardKind = 3;																		{									Standard Window			}
		wAnimateMove = $00000001;														{Moving Windows:	Animate w/Zoom Lines	}
		wOffsetForToolBar = $00000002;												{									Offset co-ords for TB		}
		wShow = true;																				{	Hiding Windows:		Display (unhide)				}
		wHide = false;																				{									Hide window						}

																											{TOOL BAR:														}
		tbShiftWindows = $00000001;													{	Shift windows when tool bar opens					}
		tbOffsetNewWindows = $00000002;											{	Offset new windows as they are opened (if		}
																											{		the tool bar is open).									}

																											{MENUS:																}
		mFileMenu = 1;																			{	File menu number											}
		mEditMenu = 2;																			{	Edit menu number											}
		mAppleMenu = -1;																		{	Apple menu number											}
		mHelpMenu = -2;																			{	Help menu number (System 7.0 or higher)		}
		mApplicationsMenu = -3;																{	Applications menu num (Sys 7.0 or higher)		}
		mDividingLine = '-';																		{	Dividing line														}
		AppleChar = char($14);																{	Apple character												}
		CheckChar = char($12);																{	Check Mark character										}
		DiamondChar = char($13);															{	Diamond character											}
		DotChar = char($A5);																	{	Dot (or bullet) character									}
		NoChar = char($00);																	{	no character													}

																											{BUTTONS:															}
		bUseWFont = $00000008;															{	Use parent window's font								}
		bDefault = $00010000;																{	Default for the window									}
		bCmdKey = $00020000;																{	Button is selectable via command key			}
		bColorButton = $00080000;														{	Use color settings for this button					}
		bHidden = $00100000;																{	Create a hidden button									}
		bAutoMoveSize = $00200000;													{	Auto-move/size as window's size changes	}
		selected = true;																			{	Button is selected (i.e. checked)					}
		notSelected = false;																	{	Button is not selected										}
																											{	For non-standard custom CDEFs only:			}
		bCDEFPushButton = $80000000;												{		Control is a push button								}
		bCDEFRadioButton = $40000000;												{		Control is a radio button								}
		bCDEFCheckBox = $20000000;													{		Control is a check box									}

																											{SCROLL BARS:													}
		scrlLeftEdge = -32768;																{	Left edge of document									}
		scrlTopEdge = -32768;																{	Top edge of document										}
		scrlRightEdge = 32767;																{	Right edge of document									}
		scrlBottomEdge = 32767;															{	Bottom edge of document								}
		scrlStandard = $00000010;															{	Standard scroll bar (default)							}
		scrlLiveScroll = $00010000;														{	Live scrolling when dragging thumb				}
		scrlValueLimit = $00020000;														{	Value is limited by minimum/maximum limit		}
		scrlNoObscure = $00040000;														{	Don't obscure scroll bar on inactive window	}
		scrlColorScrollBar = $00080000;												{	Use color settings for this scroll bar				}
		scrlHidden = $00100000;															{	Create a hidden scroll bar								}
		scrlAutoMoveSize = $00200000;												{	Auto-move/size as window's size changes	}

																											{LIST BOXES:														}
																											{	Standard Apple constants for backwards		}
																											{	compatibility.  Don't mix with T+ constants:	}
		lUseSense = 4;																			{		Shift senses state of initial line					}
		lNoExtend = 16;																			{		Shift won't extend selection						}
		lNoDisjoint = 32;																			{		Click deselects previsous selections			}
		lExtendDrag = 64;																		{		Drag extends without shift key					}
		lOnlyOne = -128;																			{		Prevent multiple selections							}
																											{	Tools Plus List Box constants:						}
		listDefault = $00000000;																{		Default list box											}
		listNoFrame = $00040000;															{		Don't draw frame around the list box			}
		listColorList = $00080000;															{		Use color settings for this list box				}
		listHidden = $00100000;																{		Create a hidden list box								}
		listAutoMoveSize = $00200000;													{		Auto-move/size as window's size chg		}
		listUseSense = $00400000;														{		Shift senses state of initial line					}
		listNoExtend = $00800000;															{		Shift won't extend selection						}
		listNoDisjoint = $01000000;														{		Click deselects previsous selections			}
		listExtendDrag = $02000000;														{		Drag extends without shift key					}
		listOnlyOne = $04000000;															{		Prevent multiple selections							}

																											{BUTTONS, MENUS, SCROLL BARS & ICONS:	}
		enabled = true;																			{	Object is enabled (active)								}
		disabled = false;																			{	Object is disabled (dim, inactive)					}

																											{EDIT FIELDS:														}
		teAllowCR = $00000100;																{	Allow CR in field												}
		teNoCR = $00000000;																	{	Disallow CR in field											}
		teBox = $00000000;																	{	Draw box around field										}
		teNoBox = $00000200;																{	Don't draw box around field								}
		teLengthLimit = $00000400;														{	Limit typing to field's length								}
		teResizeHdl = $00000800;															{	Resize text handle to save RAM						}
		teFilter = $00001000;																	{	Use current field filter										}
		teCstring = $00002000;																{	C string text format (32K max)						}
		teDisabled = $00004000;															{	Field is disabled												}
		teHidden = $00008000;																{	Create a hidden field										}
																											{	Default selection on activation:						}
		teTabSelectEnd = $00010000;													{		Insertion point at end									}
		teTabSelectStart = $00020000;													{		Insertion point at start									}
		teTabSelectAll = $00000000;														{		Select all text												}
		teBuffered = $00040000;															{	Accelerate large field with buffer						}
		teAutoMoveSize = $00080000;													{	Auto-move/size as window's size changes	}
		teNoResetOnDeactivate = $00100000;										{	Retain scrolling on deactivate							}
		teLiveScroll = $00200000;															{	Live scrolling using scroll bars						}
		teVScroll = $00400000;																{	Field has a vertical scroll bar							}
																											{	Vert Scroll:	Bring scroll bar's top down by	}
		teVScrollDown15 = $01000000;													{		15 pixels														}
		teVScrollDown30 = $02000000;													{		30 pixels														}
		teVScrollDown45 = $03000000;													{		45 pixels														}
		teVScrollDown60 = $04000000;													{		60 pixels														}
		teVScrollDown75 = $05000000;													{		75 pixels														}
		teVScrollDown90 = $06000000;													{		90 pixels														}
		teVScrollDown105 = $07000000;												{		105 pixels													}
		teVScrollDown120 = $08000000;												{		120 pixels													}
		teVScrollDown135 = $09000000;												{		135 pixels													}
		teVScrollDown150 = $0A000000;												{		150 pixels													}
		teVScrollDown165 = $0B000000;												{		165 pixels													}
		teVScrollDown180 = $0C000000;												{		180 pixels													}
		teVScrollDown195 = $0D000000;												{		195 pixels													}
		teVScrollDown210 = $0E000000;												{		210 pixels													}
		teVScrollDown225 = $0F000000;												{		225 pixels													}
																											{	Hor. Scroll:	Bring scroll bar's left side right}
		teHScrollRight15 = $10000000;													{		15 pixels														}
		teHScrollRight30 = $20000000;													{		30 pixels														}
		teHScrollRight45 = $30000000;													{		45 pixels														}
		teHScrollRight60 = $40000000;													{		60 pixels														}
		teHScrollRight75 = $50000000;													{		75 pixels														}
		teHScrollRight90 = $60000000;													{		90 pixels														}
		teHScrollRight105 = $70000000;												{		105 pixels													}
		teHScrollRight120 = $80000000;												{		120 pixels													}
		teHScrollRight135 = $90000000;												{		135 pixels													}
		teHScrollRight150 = $A0000000;												{		150 pixels													}
		teHScrollRight165 = $B0000000;												{		165 pixels													}
		teHScrollRight180 = $C0000000;												{		180 pixels													}
		teHScrollRight195 = $D0000000;												{		195 pixels													}
		teHScrollRight210 = $E0000000;												{		210 pixels													}
		teHScrollRight225 = $F0000000;												{		225 pixels													}
		teBoxNoCR = teBox + teNoCR;													{	Box & CR:	Box around field, no CR allowed	}
		teBoxCR = teBox + teAllowCR;													{						Box around field, CR allowed		}
		teNoBoxNoCR = teNoBox + teNoCR;											{						No box, no CR allowed					}
		teNoBoxCR = teNoBox + teAllowCR;											{						No box, CR allowed						}
		teLeftEdge = -32768;																	{	Co-ords:		Window's left edge						}
		teTopEdge = -32768;																	{						Window's top edge						}
		teRightEdge = 32767;																	{						Window's right edge					}
		teBottomEdge = 32767;																{						Window's bottom edge				}
		teJustLeft = 0;																				{	Alignment:	Text is left aligned						}
		teJustCenter = 1;																		{						Text is centered							}
		teJustRight = -1;																			{						Text is right aligned						}
		teSelectStart = 1;																		{	Selection:	Beginning of text							}
		teSelectEnd = 2;																			{						End of text									}
		teSelectAll = 3;																			{						All text											}
		teSelectDefault = 0;																	{						Default (as per field's spec)		}

																											{TEXT DRAWING:												}
		teWhiteBack = $00000000;															{	White background											}
		teBackdrop = $00000001;															{	Draw on backdrop color									}
		teColorBack = $00000002;															{	Color background											}
		teNoBack = $00000004;																{	Transparent background									}
		teBlackText = $00000000;															{	Black text														}
		teColorText = $00000010;															{	Foreground colored text									}
		teBlackOnBackdrop = teBlackText + teBackdrop;						{	Combinations:	Black text on backdrop			}
		teBlackOnWhite = teBlackText + teWhiteBack;							{							Black text on white					}
		teBlackOnColor = teBlackText + teColorBack;							{							Black text on color					}
		teBlackOnClear = teBlackText + teNoBack;								{							Black text, no background		}
		teColorOnBackdrop = teColorText + teBackdrop;						{							Color text on backdrop			}
		teColorOnWhite = teColorText + teWhiteBack;							{							Color text on white					}
		teColorOnColor = teColorText + teColorBack;							{							Color text on color					}
		teColorOnClear = teColorText + teNoBack;								{							Color text, no background		}

																											{PASTE INTO FIELD:											}
		teReplace = true;																			{	Replace field contents									}
		teInsert = false;																			{	Insert text into field											}

																											{DISABLED FIELDS:											}
		teNeverDimBWText = $00000001;												{	Never dim text (Black & White)						}
		teNeverDimColorText = $00000002;											{	Never dim text (color)										}
		teColSys6Text = $00000004;														{	Colorize System 6 text									}
		teNeverDimBWBox = $00000008;												{	Never dim outline (Black & White)					}
		teNeverDimColorBox = $00000010;											{	Never dim outline (color)									}
		teColSys6Box = $00000020;														{	Colorize Sys 6 outline										}
		teClickBeep = $00000040;															{	Beep when disabled										}
		teDfltDisabledLook = $00000000;												{	Use default settings										}

																											{FIELD FILTERS:													}
		teIgnoreCase = $00000001;														{	Disable case sensing										}
		teIgnoreDiac = $00000002;															{	Disable diacritical sensing								}
		teShiftCaseUp = $00000004;														{	Shift chars to upper case								}
		teShiftCaseDown = $00000008;													{	Shift chars to lower case									}

																											{PICTURE BUTTONS:											}
		picbutInstantEvent = $80000000;												{	Report event on mouse-down							}
		picbutTrackWithHilite = $40000000;											{	Track using hiliting, like a radio button			}
		picbutLockSelected = $20000000;												{	Lock if selected (mouse can't deselect)			}
		picbutSwitchSelected = $10000000;											{	Switch 'selected' state if clicked						}
		picbutRepeatEvents = $08000000;											{	Repeat event when button is held down			}
		picbutAutoValueChg = $04000000;											{	Automatically change button's value				}
		picbutScaleLinear = $00000000;												{	Rate of automatic value change					}
		picbutScaleSlowAccel = $01000000;											{		Linear, Slow Acceleration,							}
		picbutScaleMedAccel = $02000000;											{		Medium Acceleration, and							}
		picbutScaleFastAccel = $03000000;											{		Fast Acceleration.										}
		picbutLinear = 0;																			{		Linear		(use in structure only)					}
		picbutSlowAccel = 1;																	{		Slow			(use in structure only)					}
		picbutMedAccel = 2;																	{		Medium	(use in structure only)					}
		picbutFastAccel = 3;																	{		Fast			(use in structure only)					}
		picbutValueWrap = $00800000;													{	Button's range of values 'wrap' around			}
		picbutLeftRightSplit = $00400000;												{	Left side reduces value, right increases			}
		picbutTopBottomSplit = $00200000;											{	Top increases value, bottom reduces				}
		picbutMultiStage = $00100000;													{	Button has multiple stages								}
		picbutBigSICN3D = $00080000;													{	Create a larger SICN 3D button						}
		picbutUsePICTS = $00040000;													{	Use PICTs instead of icons								}
		picbutGray4use8 = $00020000;													{	Use 8-bit color pict on 4-bit gray monitor			}
		picbutHidden = $00000200;														{	Create a hidden picture button						}
		picbutAutoMoveSize = $00000001;											{	Auto-move as window's size changes			}
																											{	Selection Effects											}
		picbutSelectDarken = $00010000;												{		Darken image												}
		picbutSelectDarkenSICN3D = $00008000;									{		Darken (and push in) a 3D SICN icon			}
		picbutSelectLightenSICN3D = $00004000;								{		Lighten (and push in) a 3D SICN icon			}
		picbutSelectPushedSICN3D = $00002000;								{		Same color (and push in) a 3D SICN icon	}
		picbutSelectAltImage = $00000400;											{		Use an alternate image								}
																											{	Disabling Effects											}
		picbutDimUsingBlackLite = $00000100;										{		Overlay Black color using Lt Gray pat.		}
		picbutDimUsingWhiteLite = $00000080;										{		Overlay White color using Lt Gray pat.		}
		picbutDimUsingWhite = $00000040;											{		Overlay White color using Gray pat.			}
		picbutDimLeaveBorder = $00000008;											{		Leave border when applying effect				}
		picbutDimAltImage = $00000004;												{		Use an alternate image								}
		picbutDimNoChange = $00000002;												{		Button looks the same when disabled			}

																											{POP-UP MENUS:												}
		popupHidden = $00008000;														{	Create a hidden pop-up menu							}
		popupAutoMoveSize = $00004000;											{	Auto-move/size as window's size changes	}
		popupHasBackground = $00000200;											{	Pop-Up Menu is drawn over an image				}
		popupNeverDimOutline = $00000100;										{	Never dim the control's outline						}
		popupNeverDimSelection = $00000080;										{	Never dim the selected item's text					}
		popupNeverDimTitle = $00000040;												{	Never dim the title											}
		popupNoArrow = $00000020;														{	Is the "down arrow" hidden								}
		popupMultiSelect = $00000010;													{	Allow multiple items to be selected					}
		popupUseWFont = $00000008;													{	Use the window's font for the menu					}
		popupIconTitle = $00000004;														{	Draw icon in the control's title							}
		popupFixedTitle = $00000002;													{	Is a fixed title displayed in the control				}
		popupDefaultType = $00000000;												{	Default menu (sys font, 1 item, no icon)			}

																											{PANELS:															}
		panFillBack = $00000001;															{	Fill panel with background color						}
		panOutlined = $00000002;															{	Always draw outline around panel					}
		panOutline4bit = $00000004;														{	Draw outline on 4-bit monitors							}
		panBlackBorder = $00000008;													{	Draw black border instead of gray					}
		panBWGrayBorder = $00000010;												{	Draw gray pattern border on B&W monitor		}
		panUseWFont = $00000020;														{	Draw title using window's font							}
		panCustomColors = $00000040;													{	Use custom colors instead of standard ones	}
		panColorText = $00000080;														{	Use foreground color for text							}
		panColorBorder = $00000100;													{	Use foreground color for border						}
		panColorBack = $00000200;														{	Use background color for background			}
		panNoBackdrop = $00000400;													{	Use standard or custom background color		}
																											{		instead of window's backdrop color			}
		panAutoDeselect = $00000800;													{	Auto-deselect buttons in this group				}
																											{	Title alignment:												}
		panLeftTitle = $00001000;															{		Left (default)												}
		panRightTitle = $00002000;														{		Right															}
		panCenterTitle = $00003000;														{		Center															}
																											{	Title's 3D styling:												}
		panPlainTitle = $00000000;															{		Plain title (no 3D effect)								}
		panRaiseTitle = $00010000;														{		Raised with light shadow								}
		panRaiseTitleDark = $00020000;												{		Raised with heavy shadow							}
		panInsetTitle = $00030000;														{		Inset with light shadow								}
		panInsetTitleDark = $00040000;													{		Inset with heavy shadow								}
																											{	Shadow styling:												}
		panNoShadow = $00000000;														{		No shadow (default)									}
		panRaiseShadow = $00080000;													{		Panel raises from window							}
		panInsetShadow = $00100000;													{		Panel sinks into window								}
																											{	Round-corner Width:										}
		panRoundCorner1 = $01000000;												{		RoundRect oval size of 1 pixel					}
		panRoundCorner2 = $02000000;												{		RoundRect oval size of 2 pixels					}
		panRoundCorner3 = $03000000;												{		RoundRect oval size of 3 pixels					}
		panRoundCorner4 = $04000000;												{		RoundRect oval size of 4 pixels					}
		panRoundCorner5 = $05000000;												{		RoundRect oval size of 5 pixels					}
		panRoundCorner6 = $06000000;												{		RoundRect oval size of 6 pixels					}
		panRoundCorner7 = $07000000;												{		RoundRect oval size of 7 pixels					}
		panRoundCorner8 = $08000000;												{		RoundRect oval size of 8 pixels					}
		panRoundCorner9 = $09000000;												{		RoundRect oval size of 9 pixels					}
		panRoundCorner10 = $0A000000;												{		RoundRect oval size of 10 pixels				}
		panRoundCorner11 = $0B000000;												{		RoundRect oval size of 11 pixels				}
		panRoundCorner12 = $0C000000;												{		RoundRect oval size of 12 pixels				}
		panRoundCorner13 = $0D000000;												{		RoundRect oval size of 13 pixels				}
		panRoundCorner14 = $0E000000;												{		RoundRect oval size of 14 pixels				}
		panRoundCorner15 = $0F000000;												{		RoundRect oval size of 15 pixels				}
		panRoundCorner16 = $10000000;												{		RoundRect oval size of 16 pixels				}
		panRoundCorner17 = $11000000;												{		RoundRect oval size of 17 pixels				}
		panRoundCorner18 = $12000000;												{		RoundRect oval size of 18 pixels				}
		panRoundCorner19 = $13000000;												{		RoundRect oval size of 19 pixels				}
		panRoundCorner20 = $14000000;												{		RoundRect oval size of 20 pixels				}
		panRoundCorner21 = $15000000;												{		RoundRect oval size of 21 pixels				}
		panRoundCorner22 = $16000000;												{		RoundRect oval size of 22 pixels				}
		panRoundCorner23 = $17000000;												{		RoundRect oval size of 23 pixels				}
		panRoundCorner24 = $18000000;												{		RoundRect oval size of 24 pixels				}
		panRoundCorner25 = $19000000;												{		RoundRect oval size of 25 pixels				}
		panRoundCorner26 = $1A000000;												{		RoundRect oval size of 26 pixels				}
		panRoundCorner27 = $1B000000;												{		RoundRect oval size of 27 pixels				}
		panRoundCorner28 = $1C000000;												{		RoundRect oval size of 28 pixels				}
		panRoundCorner29 = $1D000000;												{		RoundRect oval size of 29 pixels				}
		panRoundCorner30 = $1E000000;												{		RoundRect oval size of 30 pixels				}
		panRoundCorner31 = $1F000000;												{		RoundRect oval size of 31 pixels				}
		panAutoMoveSize = $40000000;												{	Auto-move/size as window's size changes	}
		panHidden = $80000000;															{	Panel is hidden												}
																											{	Popular combinations:									}
		panGroupBox = panLeftTitle + panBlackBorder + panNoShadow + panAutoDeselect;		{	Standard group box	}
		pan3DGroupBox = panLeftTitle + panInsetShadow + panRaiseTitle + panAutoDeselect;	{	3D group box			}

																											{CURSORS:															}
		arrowCursor = 0;																			{	Standard arrow cursor										}

																											{ALERTS:															}
		OkAltBut = 1;																				{	OK					(Buttons refs)							}
		CanAltBut = 2;																				{	Cancel																}
		YesAltBut = 3;																				{	Yes																	}
		NoAltBut = 4;																				{	No																	}
		ContAltBut = 5;																			{	Continue															}
		SkipAltBut = 6;																			{	Skip																	}
		QuitAltBut = 7;																				{	Quit																	}
		NoButtonAlert = 0;																		{	No buttons		(Alert Defs)								}
		OkAlert = 11100;																			{	OK (default)														}
		CanAlert = 11200;																		{	Cancel (default)												}
		OkCanAlert = 22210;																	{	OK (default) + Cancel										}
		CanOkAlert = 21210;																	{	OK + Cancel (default)										}
		YesNoAlert = 22430;																	{	Yes (default) + No											}
		NoYesAlert = 21430;																	{	Yes + No (default)											}
		YesNoCanAlert = 33243;																{	Yes (default) + No + Cancel								}
		NoYesCanAlert = 32243;																{	Yes + No (default) + Cancel								}

																											{NOTIFICATION:													}
		nmSysBeep = -1;																			{	Use System Error sound									}
		nmSilentNote = 0;																		{	Silent notification											}
		nmDefaultMsg = ' ';																		{	Use default message										}
		nmNoMsg = '';																				{	Don't display an alert										}
		nmResetWhenDone = true;															{	Reset to defaults after used							}
		nmKeepSettings = false;																{	Keep settings after used									}

																											{ICONS:																}
		NoIcon = -32768;																			{	No icon used													}
		stopIcon = 0;																				{	Stop icon															}
		noteIcon = 1;																				{	Note icon															}
		cautionIcon = 2;																			{	Caution icon													}
																											{	Disabled icons' default appearance			}
		DfltIconDimBlackLtPat = $00000001;											{		Overlay Black color w/ Lt Gray pat.			}
		DfltIconDimWhiteLtPat = $00000002;											{		Overlay White color w/ Lt Gray pat.			}
		DfltIconDimWhitePat = $00000004;											{		Overlay White color w/ Gray pat.				}
		DfltIconLeaveBorder = $00000020;											{	Leave border when selected or disabled			}
		DfltIconUpdateNow = $00008000;												{	Update all windows with changes					}

																											{PICTs:																}
		pictScale1PICT = $00000000;													{	Scale PICT to specified rectangle					}
		pictUsePictRect = $00000001;													{	Use picture's rectangle									}
		pictClipToRect = $00000002;														{	Clip picture to rectangle									}
		pictOnBackdrop = $00000004;													{	Clear with backdrop col. before drawing			}
		pictOnWhite = $00000008;															{	Clear with white before drawing						}
		pictOnColor = $00000010;															{	Clear with backgnd col. before drawing			}
		pictMultiPICT = $00000020;														{	Use different PICT per monitor setting			}
		pictBWplus = $00000040;															{	Use better pict if B&W not available				}
		pictGray4plus = $00000080;														{	Use better pict if 4-bit gray not available			}
		pictColor4plus = $00000100;														{	Use better pict if 4-bit color not available		}
		pictGray8plus = $00000200;														{	Use better pict if 8-bit gray not available			}
		pictColor8plus = $00000400;														{	Use better pict if 8-bit color not available		}

																											{BITMAPS:															}
		bitmapBW = 0;																				{	Create a 1-bit B&W bitmap								}
		bitmapFromWindow = 1;																{	PixMap based on window's max pixel depth	}
		bitmapFromGDevice = 2;																{	PixMap based on specified GDevice				}
		bitmapFromCurrentGDevice = 3;													{	PixMap based on current GDevice					}
		bitmapFromMaxGDevice = 4;														{	PixMap based on maximum GDevice				}

																											{MISCELLANEOUS:											}
		on = true;																						{	Synonym for 'true'											}
		off = false;																					{	Synonym for 'false'											}
		none = 0;																						{	Used primarily for polling									}
		maxNullTime = $7FFFFFFF;															{	Infinite time between doNothing evts				}

																											{ZOOM LINES:													}
		ZoomAcross = 0;																			{	Transitional														}
		ZoomIn = -1;																				{	Zoom inward (further away)								}
		ZoomOut = 1;																				{	Zoom outward (nearer)									}




	type

	{ -   -   -   -   -   -   -   -   -   -   These record "types" are used for information transfer between   -   -   -   -   -   -   -   -   -   -   -	}
	{														your application and Tools Plus libraries.															}



	{= Polling record's "event modifiers" info}
		TPModifiersRec = packed record												{This variable record contains an event's			}
				case integer of																	{	"modifiers" in 2 formats								}
					0: (																					{	 Macintosh Event:											}
							Num: integer															{		integer (bit operations required)					}
					);																						{																			}
					1: (																					{	 Modifier integer parsed into components:		}
							bit15, bit14, bit13: boolean;									{		(reserved bits)												}
							ControlKey: boolean;												{		Control key was down at event (=1)			}
							OptionKey: boolean;												{		Option key was down at event (=1)				}
							CapsLock: boolean;												{		Caps Lock was down at event (=1)				}
							ShiftKey: boolean;													{		Shift key was down at event (=1)				}
							CmdKey: boolean;													{		Command key was down at event (=1)		}
							MouseUp: boolean;													{		Mouse button was UP at event (=1)			}
							bit6, bit5, bit4, bit3, bit2, bit1, bit0: boolean			{		(reserved bits)												}
					);																						{																			}
			end;
	{= Polling record's "button" info}
		TPPollButtonRec = record
				Num: integer;																		{Button number													}
				DoubleClick: boolean															{Did a double-click occur?									}
			end;
	{= Polling record's "scroll bar" info}
		TPPollScrollBarRec = record
				Num: integer;																		{Scroll bar number												}
				Part: integer																		{Scroll bar's part													}
			end;
	{= Polling record's "list box" info}
		TPPollListBoxRec = record
				Num: integer;																		{List box number													}
				DoubleClick: boolean															{Did a double-click occur?									}
			end;
	{= Polling record's "menu" info}
		TPPollMenuRec = record
				Num: integer;																		{Menu number														}
				Item: integer																		{Menu item number												}
			end;
	{= Polling record's "key-stroke" info}
		TPPollKeyRec = packed record
				Code: integer;																		{Logical key number of the typed key					}
				Chr: char;																			{ASCII character generated by typed key			}
				Unused: byte																		{	(reserved byte)												}
			end;
	{= Polling record's "mouse location and time" info for mouse-down and mouse-up events}
		TPPollMousePointRec = record
				Where: point;																		{Event location in local co-ordinates					}
				When: longint;																		{Event time in clock ticks from boot (1/60 sec)	}
				Modifiers: TPModifiersRec													{Event modifiers													}
			end;
	{= Polling record's "mouse click/drag" info}
		TPPollMouseRec = record
				What: integer;																		{What type of mouse event (click or drag)			}
				Down: array[1..3] of TPPollMousePointRec;						{Where & when did the mouse-down occur			}
				Up: array[1..3] of TPPollMousePointRec;							{Where & when did the mouse-up occur				}
				Where: point																		{Current mouse location in local co-ordinates		}
			end;
	{= POLLING record for Tools Plus}
		TPPollPointer = ^TPPollRecord;													{Pointer to a Polling record									}

		TPPollRecord = record																{Tools Plus Polling record								}
				What: integer;																		{What type of event has occurred						}
				Window: integer;																	{Window number of the event								}
				Button: TPPollButtonRec;													{Button number/double-click status					}
				ScrollBar: TPPollScrollBarRec;											{Scroll bar number/scroll bar part						}
				Field: integer;																		{Field number of event											}
				ListBox: TPPollListBoxRec;												{List box number/double-click status					}
				Menu: TPPollMenuRec;														{Menu number/menu item of an event					}
				Key: TPPollKeyRec;															{Logical key number & character of typed key	}
				Mouse: TPPollMouseRec;													{Click/drag info: [1..3] where & when					}
				Modifiers: TPModifiersRec;													{Modifier flags														}
				Event: EventRecord															{Macintosh Toolbox Event (raw)							}
			end;


	{= WINDOW status information}
		TPWindowStatus = record															{Window status record										}
				Kind: integer;																		{  Window kind: Tool Bar, Palette, or Standard	}
				Open: boolean;																	{  Is the window open											}
				Visible: boolean;																	{  Is this window visible (not hidden)					}
				Active: boolean;																	{  Is this window active										}
				Front: boolean;																	{  Is this the frontmost Tools Plus window			}
				Current: boolean;																{  Is this the current window								}
				WorkWindow: boolean;														{  Is this the work window									}
				EditFieldWindow: boolean;													{  Does this window have the app's active field	}
				ActiveField: integer;															{  Window's active field number							}
				StrucRect: rect;																	{  Structure rect (global).  Incl border & title bar	}
				ContRect: rect;																	{  Content rect (global).  Working area only.		}
			end;


	{= Color Pen information}
		ColorPenState = record																{Color equivalent for a 'PenState' record.  This	}
				PenState: PenState;															{	record also stores additional values for the	}
				ForegroundColor: RGBColor;												{	window's foreground and background				}
				BackgroundColor: RGBColor												{	colors.																}
			end;


	{= Picture Button Appearance & Behavior Specification (or you can use constants instead)									}
		TPPictButtonSpec = packed record											{Picture Button's appearance and behavior		}
																											{	specifications in 2 formats							}
				case integer of																	{																			}
					0: (																					{	 Parsed into components:								}
							InstantEvent: boolean;											{		Report event on mouse-down						}
							TrackWithHilite: boolean;										{		Track using hiliting, like a radio button		}
							LockSelected: boolean;											{		Lock if selected (mouse can't deselect)		}
							SwitchSelected: boolean;										{		Switch 'selected' state if clicked					}
							RepeatEvents: boolean;											{		Repeat event when button is held down		}
							AutoValueChg: boolean;											{		Automatically change button's value			}
							AutoValueScaling: 0..3;											{		Rate of change for button's value				}
							ValueWrap: boolean;												{		Button's range of values 'wrap' around		}
							LeftRightSplit: boolean;											{		Left side reduces value, right increases		}
							TopBottomSplit: boolean;										{		Top increases value, bottom reduces			}
							MultiStage: boolean;												{		Button has multiple stages							}
							BigSICN3D: boolean;												{		Create a larger SICN 3D button					}
							UsePICTS: boolean;												{		Use PICTs instead of icons							}
							Gray4use8: boolean;												{		Use 8-bit color pict on 4-bit gray monitor		}
																											{	   Selection Effects										}
							SelectDarken: boolean;											{		Darken image												}
							SelectDarkenSICN3D: boolean;								{		Darken (and push in) a 3D SICN icon			}
							SelectLightenSICN3D: boolean;								{		Lighten (and push in) a 3D SICN icon			}
							SelectPushedSICN3D: boolean;								{		Same color (and push in) a 3D SICN icon	}
							bit12, bit11: boolean;												{		   (reserved bits)											}
							SelectAltImage: boolean;										{		Use an alternate image								}
							Hidden: boolean;														{	   Create a hidden button									}
																											{	   Disabling Effects										}
							DimUsingBlackLite: boolean;									{		Overlay Black color using Lt Gray pat.		}
							DimUsingWhiteLite: boolean;									{		Overlay White color using Lt Gray pat.		}
							DimUsingWhite: boolean;										{		Overlay White color using Gray pat.			}
							bit5, bit4: boolean;													{		   (reserved bits)											}
							DimLeaveBorder: boolean;										{		Leave border when applying effect				}
							DimAltImage: boolean;											{		Use an alternate image								}
							DimNoChange: boolean;											{		Button looks the same when disabled			}
							AutoMoveSize: boolean;											{	Auto-move/size as window's size changes	}
					);																						{																			}
					1: (																					{	 Longint equivalent:										}
							Num: longint;															{		Specification longint									}
					);																						{																			}
			end;


	{= Pop-Up Menu Appearance & Behavior Specification (or you can use constants instead)	}
		TPPopUpMenuSpec = packed record											{Pop-Up Menu's appearance and behavior			}
																											{	specifications in 2 formats							}
				case integer of																	{																			}
					0: (																					{	 Parsed into components:								}
							bits31to16: integer;													{		   (reserved bits)											}
							Hidden: boolean;														{		Create a hidden pop-up menu						}
							AutoMoveSize: boolean;											{		Auto-move/size as window's size chgs		}
							bit13, bit12, bit11, bit10: boolean;							{		   (reserved bits)											}
							HasBackground: boolean;										{		Pop-up menu is drawn over an image			}
							NeverDimOutline: boolean;										{		Never dim the control's outline					}
							NeverDimSelectedItem: boolean;							{		Never dim the selected item's text				}
							NeverDimTitle: boolean;											{		Never dim the title										}
							NoArrow: boolean;													{		Is the "down arrow" hidden							}
							MultipleSelections: boolean;									{		Allow multiple items to be selected				}
							UseWindowFont: boolean;										{		Display using window's font						}
							IconInTitle: boolean;												{		Draw icon in the control's title						}
							FixedTitle: boolean;													{		Is a fixed title displayed in the control			}
							bit0: boolean;															{		   (reserved bit)											}
					);																						{																			}
					1: (																					{	 Integer equivalent:										}
							Num: longint;															{		Specification longint									}
					);																						{																			}
			end;																							{																			}


	{= Picture Drawing Appearance & Behavior Specification (or you can use constants instead)	}
		TPDrawPictSpec = packed record												{Picture drawing appearance and behavior			}
																											{	specifications in 2 formats							}
				case integer of																	{																			}
					0: (																					{	 Parsed into components:								}
							bits31to16: integer;													{		   (reserved bits)											}
							bit15, bit14, bit13: boolean;									{		   (reserved bits)											}
							bit12, bit11: boolean;												{		   (reserved bits)											}
							Color8plus: boolean;												{		Use better pict if 8-bit color not available	}
							Gray8plus: boolean;												{		Use better pict if 8-bit gray not available		}
							Color4plus: boolean;												{		Use better pict if 4-bit color not available	}
							Gray4plus: boolean;												{		Use better pict if 4-bit gray not available		}
							BWplus: boolean;													{		Use better pict if B&W not available			}
							MultiPICT: boolean;													{		Use different PICT per monitor setting		}
							DrawOnColor: boolean;											{		Clear with backgnd col. before drawing		}
							DrawOnWhite: boolean;											{		Clear with white before drawing					}
							DrawOnBackdrop: boolean;									{		Clear with backdrop col. before drawing		}
							ClipToRect: boolean;												{		Clip picture to rectangle								}
							UsePictRect: boolean;											{		Use picture's rectangle								}
					);																						{																			}
					1: (																					{	 Longint equivalent:										}
							Num: longint;															{		Specification longint									}
					);																						{																			}
			end;





{==================================== I N I T I A L I Z A T I O N ====================================	}
{Initialize Tools Plus}
	function InitToolsPlus (MoreHandles: integer;								{Number of additional handle blocks					}
							MaxWindows: integer;												{Maximum number of windows required				}
							TEBufferSize: integer;											{TextEdit buffer size (255 to 32767)					}
							InitSpec: longint														{Initialization specifications								}
							): Boolean;																{Was initialization successful								}

{Set the size of the stack in a 68K application}
 	procedure Set68KStackSize (bytes: longint);								{Stack's new size												}

{Change the stack's size}
	 procedure ChangeStackSize (bytes: longint);								{No. of bytes by whick stack size is changed		}



{======================================= W I N D O W S ========================================	}
{Open a window and make it current}
	procedure WindowOpen (Window: integer;										{Window number													}
							left, top, right, bottom: integer;								{Window's co-ordinates (global)							}
							Title: string;																{Window's title (if applicable)								}
							Spec: longint;															{Window specifications and procID						}
							goAwayFlag, modalFlag: Boolean);							{Include Close Box?  Is window modal?				}

{Open a window and make it current (co-ordinates specified as a 'rect') }
	procedure WindowOpenRect (Window: integer;								{Window number													}
							Bounds: rect;															{Window's co-ordinates (global)							}
							Title: string;																{Window's title (if applicable)								}
							Spec: longint;															{Window specifications and procID						}
							goAwayFlag, modalFlag: Boolean);							{Include Close Box?  Is window modal?				}

{Open the tool bar and make it current}
	procedure ToolBarOpen (Window: integer;										{Window number													}
							Height: integer;														{Tool bar height													}
							Spec: longint);															{Appearance/behavior specifications					}

{Set the backdrop color for new windows}
	procedure BackdropColor (Color: RGBColor);								{Backdrop color for new windows						}

{Reset backdrop color for new windows to white}
	procedure NoBackdropColor;

{Set a window's backdrop color}
	procedure SetBackdropColor (Window: integer;								{Window number													}
							Color: RGBColor);													{Backdrop color													}

{Close a window}
	procedure WindowClose (Window: integer);									{Window number													}

{Change a window's size}
	procedure WindowSize (Window: integer;										{Window number													}
							Width, Height: integer;											{Window's new width and height							}
							Update: boolean);													{Force doRefresh event for newly exposed rgn	}

{Move a window to the specified co-ordinates}
	procedure WindowMove (Window: integer;										{Window number													}
							hGlobal: integer;														{Horizontal co-ordinates (global)							}
							vGlobal: integer;														{Vertical co-ordinates (global)								}
							Spec: longint);															{Behavior specification										}

{Hide or show a window}
	procedure WindowDisplay (Window: integer;									{Window number													}
							Show: boolean);														{Should the window be shown								}

{Make a specified window the "active" and "current" window}
	procedure ActivateWindow (Window: integer);								{Window number													}

{Set a window's title}
	procedure WindowTitle (Window: integer;										{Window number													}
							Title: string);															{Window's title (if applicable)								}

{Set the current window's "growing" limits (i.e. maximum/minimum size) }
	procedure SetWindowSizeLimits (minHoriz, minVert, maxHoriz, MaxVert: integer);	{Window's size limits in pixels	}

{Set the current window's standard co-ordinates and user co-ordinates for "zooming"}
	procedure SetWindowZoom (userRect, stdRect: rect);					{User & standard co-ordinates (global)				}

{Get the current window's user co-ordinates & standard co-ordinates for "zooming"}
	procedure GetWindowZoom (var userRect, stdRect: Rect);			{User & standard co-ordinates (global)				}

{Make a specified window "current", but do not activate it}
	procedure CurrentWindow (Window: integer);									{Window number													}

{Make the "active" window "current"}
	procedure CurrentWindowReset;

{Get a window's status}
	procedure WindowStatus (Window: integer;									{Window number													}
							var Status: TPWindowStatus);								{Window's status record										}

{Refresh Tools Plus objects in a window}
	procedure RefreshToolsPlusInWindow (Window: integer);				{Window number													}

{Get the active window number (last used window if Tool Bar and/or Floating Palettes are open) }
	function ActiveWindowNumber: integer;											{Window number of active window						}

{Get the current window number}
	function CurrentWindowNumber: integer;										{Window number of current window						}

{Get the front most window number}
	function FirstWindowNumber: integer;											{Window number of front most window				}
																											{	window is open.												}
{Get the Tool Bar's window number}
	function ToolBarNumber: integer;													{Tool Bar's window number									}

{Get the first floating Palette's window number}
	function FirstPaletteNumber: integer;												{Front most floating Palette's window number		}

{Get the first standard window's number (not Tool Bar or Floating Palette) }
	function FirstStdWindowNumber: integer;										{Front most standard window's number				}

{Get the working window number}
	function WorkWindowNumber: integer;											{Working window number										}

{Get the window number that contains the active editing field}
	function EditFldWindowNumber: integer;										{Window number containing active editing field	}

{Determine if a window is open}
	function WindowIsOpen (Window: integer										{Window number													}
							): boolean;																{Is the window open?											}

{Determine if a window is visible (open and not hidden) }
	function WindowIsVisible (Window: integer									{Window number													}
							): boolean;																{Is the window visible?										}

{Determine if a window is active}
	function WindowIsActive (Window: integer										{Window number													}
							): boolean;																{Is the window active?											}

{Determine the type of window}
	function WindowKind (Window: integer											{Window number													}
							): integer;																	{Kind of window													}

{Get a window's "window pointer" }
	function WindowPointer (Window: integer										{Window number													}
							): WindowPtr;															{Window's pointer												}

{Automatically move/resize subsequently created objects as their window's size changes}
	procedure AutoMoveSize (left: boolean;										{Object's left side tracks window's right edge		}
							top: boolean;															{Object's top tracks window's bottom edge		}
							right: boolean;															{Object's right side tracks window's right edge	}
							bottom: boolean);													{Object's bottom tracks window's bottom edge	}

{Hide or show the Finder and other applications}
	procedure FinderDisplay (Show: boolean);										{Should the other apps be shown?						}



{======================================== B U T T O N S ========================================}
{Create a new button}
	procedure NewButton (Button: integer;											{Button number													}
							left, top, right, bottom: integer;								{Button's co-ordinates (local)								}
							Title: string;																{Button's title														}
							Spec: longint;															{Button's appearance & behavior specifications}
							EnabledFlag, SelectedFlag: boolean);					{Enable the button?  Select the button?				}

{Create a new button  (co-ordinates specified as a 'rect') }
	procedure NewButtonRect (Button: integer;									{Button number													}
							Bounds: rect;															{Button's co-ordinates (local)								}
							Title: string;																{Button's title														}
							Spec: longint;															{Button's appearance & behavior specifications}
							EnabledFlag, SelectedFlag: boolean);					{Enable the button?  Select the button?				}

{Set colors for new buttons}
	procedure ButtonColors (Frame: RGBColor;									{Frame's color														}
							Body: RGBColor;														{Body's color														}
							Text: RGBColor;														{Text's color														}
							Back: RGBColor);													{Background color												}

{Reset button colors for new buttons to 'black on white'}
	procedure NoButtonColors;

{Delete a button}
	procedure DeleteButton (Button: integer);										{Button number													}

{Delete a button without removing its image}
	procedure KillButton (Button: integer);											{Button number													}

{Hide or show a button}
	procedure ButtonDisplay (Button: integer;										{Button number													}
							Show: boolean);														{Should the button be shown?								}

{Hide button but do not remove the image on the window}
	procedure ObscureButton (Button: integer);									{Button number													}

{Get a button's co-ordinates}
	procedure GetButtonRect (Button: integer;									{Button number													}
							var Bounds: rect);													{Enclosing rectangle co-ordinates (local)			}

{Enable/disable a button}
	procedure EnableButton (Button: integer;										{Button number													}
							EnabledFlag: boolean);											{Enable the button?												}

{Select/deselect a button}
	procedure SelectButton (Button: integer;										{Button number													}
							SelectedFlag: boolean);											{Select the button?												}

{Get a button's minimum setting (for custom CDEFs)}
	function GetButtonMin (Button: integer											{Button number													}
							): integer;																	{Button's minimum setting									}

{Set a button's minimum setting (for custom CDEFs)}
	procedure SetButtonMin (Button: integer;										{Button number													}
							minimum: integer);													{Button's minimum setting									}

{Get a button's maximum setting (for custom CDEFs)}
	function GetButtonMax (Button: integer											{Button number													}
							): integer;																	{Button's maximum setting									}

{Set a button's maximum setting (for custom CDEFs)}
	procedure SetButtonMax (Button: integer;										{Button number													}
							maximum: integer);													{Button's maximum setting									}

{Get a button's current value (for custom CDEFs)}
	function GetButtonVal (Button: integer											{Button number													}
							): integer;																	{Button's current value										}

{Set a button's current value (for custom CDEFs)}
	procedure SetButtonVal (Button: integer;										{Button number													}
							value: integer);														{Button's current value										}

{Determine if a button is enabled}
	function ButtonIsEnabled (Button: integer										{Button number													}
							): boolean;																{Is the button enabled?										}

{Determine if a button is selected}
	function ButtonIsSelected (Button: integer									{Button number													}
							): boolean;																{Is the button selected?										}

{Set a button's title}
	procedure ButtonTitle (Button: integer;											{Button number													}
							Title: string);															{Button's title														}

{Set a button's color}
	procedure SetButtonColors (Button: integer;									{Button number													}
							Frame: RGBColor;													{Frame's color														}
							Body: RGBColor;														{Body's color														}
							Text: RGBColor;														{Text's color														}
							Back: RGBColor);													{Background color												}

{Get a button's colors}
	procedure GetButtonColors (Button: integer;									{Button number													}
							var Frame: RGBColor;												{Frame's color														}
							var Body: RGBColor;												{Body's color														}
							var Text: RGBColor;												{Text's color														}
							var Back: RGBColor);												{Background color												}

{Make a button the window's default button}
	procedure SetDefaultButton (Button: integer);								{Button number													}

{Remove the "default button status" from the window's default button}
	procedure NoDefaultButton;

{"Flash" a push button as though it were pressed by the user}
	procedure FlashButton (Button: integer);										{Button number													}

{Move a button to a new location}
	procedure MoveButton (Button: integer;										{Button number													}
							toHoriz: integer;														{Horizontal position in local co-ordinates			}
							toVert: integer);														{Vertical position in local co-ordinates				}

{Move a button's co-ordinates to a new location without moving the image}
	procedure OffsetButton (Button: integer;										{Button number													}
							distHoriz, distVert: integer);									{Number of pixels to be offset (horiz/vert)			}

{Change a button's size}
	procedure SizeButton (Button: integer;											{Button number													}
							width: integer;															{New width in pixels												}
							height: integer);														{New height in pixels											}

{Change a button's co-ordinates (size and/or location)}
	procedure MoveSizeButton (Button: integer;									{Button number													}
							left, top, right, bottom: integer);								{Enclosing rectangle co-ordinates (local)			}

{Change a button's co-ordinates (size and/or location,  co-ordinates specified as a 'rect') }
	procedure MoveSizeButtonRect (Button: integer;							{Button number													}
							Bounds: rect);															{Enclosing rectangle co-ordinates (local)			}

{Specify which sides of a button are automatically moved when the window is resized}
	procedure AutoMoveSizeButton (Button: integer;							{Button number													}
							left: boolean;															{Button's left side tracks window's right edge		}
							top: boolean;															{Button's top tracks window's bottom edge		}
							right: boolean;															{Button's right side tracks window's right edge	}
							bottom: boolean);													{Button's bottom tracks window's bottom edge	}



{=================================== P I C T U R E   B U T T O N S ==================================}
{Create a new Picture Button}
	procedure NewPictButton (Button: integer;									{Picture button number										}
							left, top: integer;														{Button's top-left corner in window's local co-ord}
							BaseID: integer;														{Base image's ID number									}
							Spec: longint;															{Appearance and Behavior specifications			}
							EnabledFlag, SelectedFlag: boolean;						{"Button is enabled"  & "button is selected" flags}
							minimum, value, maximum: integer);						{Minimum, current, and maximum value				}

{Delete a picture button}
	procedure DeletePictButton (Button: integer);								{Picture button number										}

{Delete a picture button without removing its image}
	procedure KillPictButton (Button: integer);										{Picture button number										}

{Get a picture button's co-ordinates}
	procedure GetPictButtonRect (Button: integer;								{Picture button number										}
							var Bounds: rect);													{Enclosing rectangle co-ordinates (local)			}

{Hide or show a picture button}
	procedure PictButtonDisplay (Button: integer;								{Picture button number										}
							Show: boolean);														{Should the button be shown?								}

{Hide picture button but do not remove the image on the window}
	procedure ObscurePictButton (Button: integer);							{Picture button number										}

{Enable/disable a picture button}
	procedure EnablePictButton (Button: integer;								{Picture button number										}
							EnabledFlag: boolean);											{Enable the picture button?									}

{Select/deselect a picture button}
	procedure SelectPictButton (Button: integer;								{Picture button number										}
							SelectedFlag: boolean);											{Select the picture button?									}

{Get a picture button's minimum setting}
	function GetPictButtonMin (Button: integer									{Picture button number										}
							): integer;																	{Picture button's minimum setting						}

{Set a picture button's minimum setting}
	procedure SetPictButtonMin (Button: integer;								{Picture button number										}
							minimum: integer);													{Picture button's minimum setting						}

{Get a picture button's maximum setting}
	function GetPictButtonMax (Button: integer									{Picture button number										}
							): integer;																	{Picture button's maximum setting						}

{Set a picture button's maximum setting}
	procedure SetPictButtonMax (Button: integer;								{Picture button number										}
							maximum: integer);													{Picture button's maximum setting						}

{Get a picture button's current value}
	function GetPictButtonVal (Button: integer									{Picture button number										}
							): integer;																	{Picture button's current value							}

{Set a picture button's current value}
	procedure SetPictButtonVal (Button: integer;								{Picture button number										}
							value: integer);														{Picture button's value										}

{Set a picture button's current value, and simultaneously select/deselect it}
	procedure SetPictButtonValSelect (Button: integer;						{Picture button number										}
							value: integer;															{Picture button's value										}
							SelectedFlag: boolean);											{Select the picture button?									}

{Set a picture button's value acceleration 'automatic value changing'}
	procedure SetPictButtonAccel (Button: integer;							{Picture button number										}
							Rate: integer);															{0 = Linear, 1-3 = Slow to fast acceleration			}

{Set a picture button's speed for 'automatic value changing'	}
	procedure SetPictButtonSpeed (Button: integer;							{Picture button number										}
							Rate: integer);															{Rate of change (value increment per second)	}

{Determine if a picture button is enabled}
	function PictButtonIsEnabled (Button: integer								{Picture button number										}
							): boolean;																{Is the button enabled?										}

{Determine if a picture button is selected}
	function PictButtonIsSelected (Button: integer								{Picture button number										}
							): boolean;																{Is the button selected?										}

{"Flash" a picture button as though it were pressed by the user}
	procedure FlashPictButton (Button: integer);									{Picture button number										}

{Move a picture button to a new location}
	procedure MovePictButton (Button: integer;									{Picture button number										}
							toHoriz: integer;														{Horizontal position in local co-ordinates			}
							toVert: integer);														{Vertical position in local co-ordinates				}

{Move a picture button's co-ordinates to a new location without moving the image}
	procedure OffsetPictButton (Button: integer;								{Picture button number										}
							distHoriz, distVert: integer);									{Number of pixels to be offset (horiz/vert)			}

{Specify which sides of a picture button are automatically moved when the window is resized}
	procedure AutoMoveSizePictButton (Button: integer;					{Picture button number										}
							left: boolean;															{Button's left/right side track window's right edge}
							top: boolean);															{Button's top/bottom track window's bottom edge}



{===================================== S C R O L L   B A R S ======================================}
{Create a new scroll bar}
	procedure NewScrollBar (ScrollBar: integer;									{Scroll bar number												}
							left, top, right, bottom: integer;								{Scroll bar's co-ordinates (local)							}
							Spec: longint;															{Appearance and behavior specification			}
							EnabledFlag: boolean;											{Enable the scroll bar?										}
							minimum, value, maximum: integer);						{Minimum, current, and maximum value				}

{Create a new scroll bar (co-ordinates specified as a 'rect') }
	procedure NewScrollBarRect (ScrollBar: integer;							{Scroll bar number												}
							Bounds: rect;															{Scroll bar's co-ordinates (local)							}
							Spec: longint;															{Appearance and behavior specification			}
							EnabledFlag: boolean;											{Enable the scroll bar?										}
							minimum, value, maximum: integer);						{Minimum, current, and maximum value				}

{Set colors for new scroll bars (for custom CDEFs) }
	procedure ScrollBarColors (Frame: RGBColor;								{Frame's color														}
							Body: RGBColor;														{Body's color														}
							Text: RGBColor;														{Text's color														}
							Thumb: RGBColor;													{Thumb's color														}
							Back: RGBColor);													{Background color												}

{Reset scroll bar colors for new scroll bars to 'black on white' (for custom CDEFs) }
	procedure NoScrollBarColors;

{Delete a scroll bar}
	procedure DeleteScrollBar (ScrollBar: integer);								{Scroll bar number												}

{Delete a scroll bar without removing its image}
	procedure KillScrollBar (ScrollBar: integer);									{Scroll bar number												}

{Get a scroll bar's co-ordinates}
	procedure GetScrollBarRect (ScrollBar: integer;							{Scroll bar number												}
							var Bounds: rect);													{Enclosing rectangle co-ordinates (local)			}

{Hide or show a scroll bar}
	procedure ScrollBarDisplay (ScrollBar: integer;								{Scroll bar number												}
							Show: boolean);														{Should the scroll bar be shown?						}

{Hide scroll bar but do not remove the image on the window}
	procedure ObscureScrollBar (ScrollBar: integer);							{Scroll bar number												}

{Enable/disable a scroll bar}
	procedure EnableScrollBar (ScrollBar: integer;								{Scroll bar number												}
							EnabledFlag: boolean);											{Enable the scroll bar?										}

{Get a scroll bar's minimum setting}
	function GetScrollBarMin (ScrollBar: integer									{Scroll bar number												}
							): integer;																	{Scroll bar's minimum setting								}

{Set a scroll bar's minimum setting}
	procedure SetScrollBarMin (ScrollBar: integer;								{Scroll bar number												}
							minimum: integer);													{Scroll bar's minimum setting								}

{Get a scroll bar's maximum setting}
	function GetScrollBarMax (ScrollBar: integer									{Scroll bar number												}
							): integer;																	{Scroll bar's maximum setting								}

{Set a scroll bar's maximum setting}
	procedure SetScrollBarMax (ScrollBar: integer;								{Scroll bar number												}
							maximum: integer);													{Scroll bar's maximum setting								}

{Get a scroll bar's current value}
	function GetScrollBarVal (ScrollBar: integer									{Scroll bar number												}
							): integer;																	{Scroll bar's current value									}

{Set a scroll bar's current value}
	procedure SetScrollBarVal (ScrollBar: integer;								{Scroll bar number												}
							value: integer);														{Scroll bar's current value									}

{Set a scroll bar's color (for custom CDEFs) }
	procedure SetScrollBarColors (ScrollBar: integer;							{Scroll bar number												}
							Frame: RGBColor;													{Frame's color														}
							Body: RGBColor;														{Body's color														}
							Text: RGBColor;														{Text's color														}
							Thumb: RGBColor;													{Thumb's color														}
							Back: RGBColor);													{Background color												}

{Get a scroll bar's colors (for custom CDEFs) }
	procedure GetScrollBarColors (ScrollBar: integer;							{Scroll bar number												}
							var Frame: RGBColor;												{Frame's color														}
							var Body: RGBColor;												{Body's color														}
							var Text: RGBColor;												{Text's color														}
							var Thumb: RGBColor;											{Thumb's color														}
							var Back: RGBColor);												{Background color												}

{Move a scroll bar to a new location}
	procedure MoveScrollBar (ScrollBar: integer;								{Scroll bar number												}
							toHoriz: integer;														{Horizontal position in local co-ordinates			}
							toVert: integer);														{Vertical position in local co-ordinates				}

{Move a scroll bar's co-ordinates to a new location without moving the image}
	procedure OffsetScrollBar (ScrollBar: integer;								{Scroll bar number												}
							distHoriz, distVert: integer);									{Number of pixels to be offset (horiz/vert)			}

{Change a scroll bar's size}
	procedure SizeScrollBar (ScrollBar: integer;									{Scroll bar number												}
							width: integer;															{New width in pixels												}
							height: integer);														{New height in pixels											}

{Change a scroll bar's co-ordinates (size and/or location)}
	procedure MoveSizeScrollBar (ScrollBar: integer;							{Scroll bar number												}
							left, top, right, bottom: integer);								{Enclosing rectangle co-ordinates (local)			}

{Change a scroll bar's co-ordinates (size and/or location,  co-ordinates specified as a 'rect') }
	procedure MoveSizeScrollBarRect (ScrollBar: integer;					{Scroll bar number												}
							Bounds: rect);															{Enclosing rectangle co-ordinates (local)			}

{Specify which sides of a scroll bar are automatically moved when the window is resized}
	procedure AutoMoveSizeScrollBar (ScrollBar: integer;					{Scroll bar number												}
							left: boolean;															{Scroll bar's left side tracks window's right edge}
							top: boolean;															{Scroll bar's top tracks window's bottom edge	}
							right: boolean;															{Scroll bar's right side tracks window's right edge}
							bottom: boolean);													{Scroll bar's bottom tracks window's bottom edge}

{Set time between line up/down events for new scroll bars (scroll bar throttling)						[Developer Kit bonus]	}
	procedure ScrollBarLineTime (Ticks: integer);								{Number of ticks between line up/down events	}

{Set time between page up/down events for new scroll bars (scroll bar throttling)						[Developer Kit bonus]	}
	procedure ScrollBarPageTime (Ticks: integer);								{Number of ticks between page up/down events}

{Set a scroll bar's time between line up/down events (scroll bar throttling)								[Developer Kit bonus]	}
	procedure SetScrollBarLineTime (ScrollBar: integer;						{Scroll bar number												}
							Ticks: integer);														{Number of ticks between line up/down events	}

{Set a scroll bar's time between page up/down events (scroll bar throttling)								[Developer Kit bonus]	}
	procedure SetScrollBarPageTime (ScrollBar: integer;					{Scroll bar number												}
							Ticks: integer);														{Number of ticks between page up/down events}

{Set an action routine for a scroll bar}
	procedure SetScrollBarAction (ScrollBar: integer;							{Scroll bar number												}
							ActionProc: ControlActionUPP);								{Action proc (called during tracking)					}

{Get info about the scroll bar currently calling an action routine}
	procedure GetScrollBarActionInfo (var Window: integer;				{Window number containing the scroll bar			}
							var ScrollBar: integer;												{Scroll bar number												}
							var Part: integer;														{Part of scroll bar originally clicked						}
							var InPart: boolean);												{Is mouse still in the part?									}



{==================================== E D I T I N G   F I E L D S ====================================}
{Allocate heap storage for a string, and initialize it}
	function NewStrHandle (StringLen: integer										{Size of string being allocated (1-32767 chars)	}
							): StringHandle;														{Handle to allocated string									}

{Create a new field}
	procedure NewField (Field: integer;													{Field number														}
							left, top, right, bottom: integer;								{Field's viewing area co-ordinates (local)			}
							hStr: Handle;															{Handle to edit field's text (nil = auto-allocate)	}
							Spec: longint;															{Behavior and display specifications					}
							Just: integer);															{Justification: left, center, right							}

{Create a new field (co-ordinates specified as a 'rect') }
	procedure NewFieldRect (Field: integer;											{Field number														}
							Bounds: rect;															{Field's viewing area co-ordinates (local)			}
							hStr: Handle;															{Handle to edit field's text (nil = auto-allocate)	}
							Spec: longint;															{Behavior and display specifications					}
							Just: integer);															{Justification: left, center, right							}

{Create a new field with a horizontal scroll bar}
	procedure NewWideField (Field: integer;											{Field number														}
							left, top, right, bottom: integer;								{Field's viewing area co-ordinates (local)			}
							DestWidth: integer;													{Destination area's width										}
							hStr: Handle;															{Handle to edit field's text (nil = auto-allocate)	}
							Spec: longint;															{Behavior and display specifications					}
							Just: integer);															{Justification: left, center, right							}

{Create a new field with a horizontal scroll bar (co-ordinates specified as a 'rect')	}
	procedure NewWideFieldRect (Field: integer;									{Field number														}
							Bounds: rect;															{Field's viewing area co-ordinates (local)			}
							DestWidth: integer;													{Destination area's width										}
							hStr: Handle;															{Handle to edit field's text (nil = auto-allocate)	}
							Spec: longint;															{Behavior and display specifications					}
							Just: integer);															{Justification: left, center, right							}

{Delete a field}
	procedure DeleteField (Field: integer);											{Field number														}

{Delete a field without removing its image}
	procedure KillField (Field: integer);													{Field number														}

{Get a field's co-ordinates}
	procedure GetFieldRect (Field: integer;											{Field number														}
							var Bounds: rect);													{Enclosing rectangle co-ordinates (local)			}

{Hide or show a field}
	procedure FieldDisplay (Field: integer;											{Field number														}
							Show: boolean);														{Should the field be shown?								}

{Hide field but do not remove the image on the window}
	procedure ObscureField (Field: integer);										{Field number														}

{Get a field's colors}
	procedure GetFieldColors (Field: integer;										{Field number														}
							var TextColor: RGBColor;										{Text's color														}
							var BackColor: RGBColor);										{Background color												}

{Set a field's colors}
	procedure SetFieldColors (Field: integer;										{Field number														}
							TextColor: RGBColor;												{Text's color														}
							BackColor: RGBColor);											{Background color												}

{Activate a  field}
	procedure ActivateField (Field: integer;											{Field number														}
							Selection: integer);													{Text selection: start, end, all or default				}

{Deactivate the active field}
	procedure DeactivateField;

{Enable/disable a field}
	procedure EnableField (Field: integer;											{Field number														}
							EnabledFlag: boolean);											{Enable the field?												}

{Process a mouse click in an inactive field.  The click has been detected by the PollSystem procedure}
	procedure ClickInField;

{Determine if the user pressed the Tab key in an active field}
	function HaveTabInField: boolean;													{Was Tab used in the active field?						}

{Process a Tab in an active field.  The Tab has been detected by the PollSystem procedure}
	procedure TabToField;

{Get the active field's edited text}
	procedure GetEditString (var EditString: Str255);							{Field's edited text												}

{Get a handle to the active field's edited text}
	function GetEditHandle: handle;														{Handle to active field's edited text						}

{Get the length (number of chars) in the active field's edited text}
	function GetEditLength: integer;													{Number of chars in active field's edited text		}

{Get a field's string}
	procedure GetFieldString (Field: integer;										{Field number														}
							var EditString: str255);											{Copy of field's string											}

{Get a handle to a field's string}
	function GetFieldHandle (Field: integer											{Field number														}
							): handle;																	{Handle to field's string										}

{Get the length (number of chars) in a field's string}
	function GetFieldLength (Field: integer											{Field number														}
							): integer;																	{Number of chars in field's string							}

{Determine if a field is empty}
	function FieldIsEmpty (Field: integer												{Field number														}
							): boolean;																{Is the specified field empty?								}

{Save the active field's edited text in the field's string}
	procedure SaveFieldString;

{Determine the active field number}
	function ActiveFieldNumber: integer;												{Active field number											}

{Turn string length limiting on/off for fields created after using this routine}
	procedure FieldLengthLimit (Limits: boolean);								{Are newly created fields length-limited?			}

{Turn automatic handle sizing on/off for fields created after using this routine}
	procedure DynamicFieldHandles (Resize: boolean);						{Are newly created fields' string hdls resizable?	}

{Specify the 'disabled' appearance and behavior for fields created after using this routine}
	procedure DisabledFieldLook (DimFieldSpec: longint);					{Specification for disabled fields							}

{Specify the 'disabled' appearance and behavior for a field}
	procedure SetDisabledFieldLook (Field: integer;							{Field number														}
							DimFieldSpec: longint);											{Specification for disabled appearance				}

{Scroll a field's text back to its default position}
	procedure ResetFieldScrolling (Field: integer);								{Field number														}

{Paste a string into a field}
	procedure PasteIntoField (Field: integer;										{Field number														}
							Text: string;																{Text being pasted into the field							}
							Replace: boolean);													{Replace all existing text in field?						}

{Paste text into a field using a pointer}
	procedure PastePIntoField (Field: integer;										{Field number														}
							Text: ptr;																	{Pointer to text being pasted into the field			}
							TextLength: integer;												{Number of characters being pasted					}
							Replace: boolean);													{Replace all existing text in field?						}

{Paste text into a field using a handle}
	procedure PasteHIntoField (Field: integer;										{Field number														}
							Text: handle;															{Handle to text being pasted into the field			}
							TextLength: integer;												{Number of characters being pasted					}
							Replace: boolean);													{Replace all existing text in field?						}

{Move a field to a new location}
	procedure MoveField (Field: integer;												{Field number														}
							toHoriz: integer;														{Horizontal position in local co-ordinates			}
							toVert: integer);														{Vertical position in local co-ordinates				}

{Move a field's co-ordinates to a new location without moving the image}
	procedure OffsetField (Field: integer;												{Field number														}
							distHoriz, distVert: integer);									{Number of pixels to be offset (horiz/vert)			}

{Change a field's size}
	procedure SizeField (Field: integer;												{Field number														}
							width: integer;															{New width in pixels												}
							height: integer);														{New height in pixels											}

{Change a field's co-ordinates (size and/or location)}
	procedure MoveSizeField (Field: integer;										{Field number														}
							left, top, right, bottom: integer);								{Enclosing rectangle co-ordinates (local)			}

{Change a field's co-ordinates (size and/or location,  co-ordinates specified as a 'rect') }
	procedure MoveSizeFieldRect (Field: integer;								{Field number														}
							Bounds: rect);															{Enclosing rectangle co-ordinates (local)			}

{Specify which sides of a field are automatically moved when the window is resized}
	procedure AutoMoveSizeField (Field: integer;								{Field number														}
							left: boolean;															{Field's left side tracks window's right edge		}
							top: boolean;															{Field's top tracks window's bottom edge			}
							right: boolean;															{Field's right side tracks window's right edge		}
							bottom: boolean);													{Field's bottom tracks window's bottom edge		}

{Define a new field filter and get its Filter Reference Number}
	function NewFieldFilter (Chars: Str255;											{The filter's characters										}
							FilterSpec: longint													{Filter specifications											}
							): integer;																	{Filter Reference Number									}

{Specify the filter used by fields created after using this routine}
	procedure CurrentFieldFilter (FilterRefNum: integer);						{Filter Reference Number (negative = disallow)	}

{Set a field's filter}
	procedure SetFieldFilter (Field: integer;											{Field number														}
							FilterRefNum: integer);											{Filter Reference Number (negative = disallow)	}

{Specify min. free memory required after 'undo' is set up															[Developer Kit bonus]	}
	procedure SetTENoUndoThresh (Threshold: longint);					{Memory threshold												}

{Specify min. free memory below which text editing is disallowed												[Developer Kit bonus]	}
	procedure SetTENoEditThresh (Threshold: longint);						{Memory threshold												}

{Specify min. free memory below which 'low memory' warning is displayed while typing			[Developer Kit bonus]	}
	procedure SetTELowMemThresh (Threshold: longint);					{Memory threshold												}



{===================================== L I S T   B O X E S  =======================================	}
{Create a new List Box}
	procedure NewListBox (ListBox: integer;										{List box number													}
							left, top, right, bottom: integer;								{List box co-ordinates (local)								}
							Spec: longint);															{Type of responses to mouse clicks, shift-click,}
																											{	dragging, etc.													}

{Create a new List Box (co-ordinates specified as a 'rect') }
	procedure NewListBoxRect (ListBox: integer;								{List box number													}
							Bounds: rect;															{List box co-ordinates (local)								}
							Spec: longint);															{Type of responses to mouse clicks, shift-click,}
																											{	dragging, etc.													}

{Delete a List Box}
	procedure DeleteListBox (ListBox: integer);									{List box number													}

{Delete a list box without removing its image}
	procedure KillListBox (ListBox: integer);										{List box number													}

{Get a list box's co-ordinates}
	procedure GetListBoxRect (ListBox: integer;								{List box number													}
							var Bounds: rect);													{Enclosing rectangle co-ordinates (local)			}

{Hide or show a List Box}
	procedure ListBoxDisplay (ListBox: integer;									{List box number													}
							Show: boolean);														{Should the list box be shown?							}

{Hide List Box but do not remove the image on the window}
	procedure ObscureListBox (ListBox: integer);								{List box number													}

{Set a line of text in a List Box}
	procedure SetListBoxText (ListBox: integer;									{List box number													}
							LineNum: integer;													{Line number														}
							Text: string);															{Text of specified line number								}

{Insert resource names in a List Box}
	procedure ResNamesToListBox (ListBox: integer;						{List box number													}
							LineNum: integer;													{Line number														}
							rType: ResType);													{Resource type													}

{Get a line of text from a List Box}
	procedure GetListBoxText (ListBox: integer;									{List box number													}
							LineNum: integer;													{Line number														}
							var Text: Str255);													{Text of specified line number								}

{Get a List Box's line number whose text is greater than or equal to the specified string}
	function SearchListBox (ListBox: integer;										{List box number													}
							Text: string																{Text being compared											}
							): integer;																	{Line number of text											}

{Select/deselect a specified List Box line}
	procedure SetListBoxLine (ListBox: integer;									{List box number													}
							LineNum: integer;													{Line number														}
							setIt: boolean);														{Selects the line?												}

{Determine if a specific List Box line is selected}
	function GetListBoxLine (ListBox: integer;									{List box number													}
							LineNum: integer														{Line number														}
							): boolean;																{Is the line selected?											}

{Get the line number of a selected line in a List Box, starting at LineNum and searching down}
	function GetListBoxLines (ListBox: integer;									{List box number													}
							LineNum: integer														{Line number														}
							): integer;																	{Next selected line												}

{Insert a blank line into a List Box}
	procedure InsertListBoxLine (ListBox: integer;								{List box number													}
							LineNum: integer);													{Line number														}

{Delete a line from a List Box}
	procedure DeleteListBoxLine (ListBox: integer;								{List box number													}
							LineNum: integer);													{Line number														}

{Delete all lines in a List Box}
	procedure ClearListBox (ListBox: integer);									{List box number													}

{Get a List Box's colors}
	procedure GetListBoxColors (ListBox: integer;								{List box number													}
							var TextColor: RGBColor;										{Text's color														}
							var BackColor: RGBColor);										{Background color												}

{Set a List Box's colors}
	procedure SetListBoxColors (ListBox: integer;								{List box number													}
							TextColor: RGBColor;												{Text's color														}
							BackColor: RGBColor);											{Background color												}

{Determine the number of items in a List Box}
	function ListBoxLineCount (ListBox: integer									{List box number													}
							): integer;																	{Number of lines in the list box							}

{Turn a List Box's text drawing on/off}
	procedure DrawListBox (ListBox: integer;										{List box number													}
							drawIt: boolean);														{Draw the list box's text?										}

{Move a list box to a new location}
	procedure MoveListBox (ListBox: integer;										{List box number													}
							toHoriz: integer;														{Horizontal position in local co-ordinates			}
							toVert: integer);														{Vertical position in local co-ordinates				}

{Move a list box's co-ordinates to a new location without moving the image}
	procedure OffsetListBox (ListBox: integer;									{List box number													}
							distHoriz, distVert: integer);									{Number of pixels to be offset (horiz/vert)			}

{Change a list box's size}
	procedure SizeListBox (ListBox: integer;										{List box number													}
							width: integer;															{New width in pixels												}
							height: integer);														{New height in pixels											}

{Change a list box's co-ordinates (size and/or location)}
	procedure MoveSizeListBox (ListBox: integer;								{List box number													}
							left, top, right, bottom: integer);								{Enclosing rectangle co-ordinates (local)			}

{Change a list box's co-ordinates (size and/or location,  co-ordinates specified as a 'rect') }
	procedure MoveSizeListBoxRect (ListBox: integer;						{List box number													}
							Bounds: rect);															{Enclosing rectangle co-ordinates (local)			}

{Specify which sides of a list box are automatically moved when the window is resized}
	procedure AutoMoveSizeListBox (ListBox: integer;						{List box number													}
							left: boolean;															{List box's left side tracks window's right edge	}
							top: boolean;															{List box's top tracks window's bottom edge		}
							right: boolean;															{List box's right side tracks window's right edge	}
							bottom: boolean);													{List box's bottom tracks window's bottom edge}



{========================================= P A N E L S =========================================}
{Create a new panel}
	procedure NewPanel (Panel: integer;												{Panel number														}
							left, top, right, bottom: integer;								{Enclosing rectangle co-ordinates (local)			}
							Title: string;																{Panel's title														}
							Spec: longint;															{Panel's appearance & behavior specification	}
							ShadowWidth: integer);											{Shadow's width in pixels									}

{Create a new panel (co-ordinates specified as a 'rect') }
	procedure NewPanelRect (Panel: integer;										{Panel number														}
							Bounds: rect;															{Enclosing rectangle co-ordinates (local)			}
							Title: string;																{Panel's title														}
							Spec: longint;															{Panel's appearance & behavior specification	}
							ShadowWidth: integer);											{Shadow's width in pixels									}

{Set standard panel colors used throughout application}
	procedure SetStandardPanelColors (Text: RGBColor;					{Text color															}
							Background: RGBColor;											{Background color												}
							Border: RGBColor;													{Border's color														}
							Hilite: RGBColor;														{Highlight color													}
							Shadow: RGBColor;												{Shadow color for panels										}
							TextShadow: RGBColor;											{Shadow color for text											}
							TextHeavyShadow: RGBColor);								{Heavy shadow color for text								}

{Get standard panel colors used throughout application}
	procedure GetStandardPanelColors (var Text: RGBColor;			{Text color															}
							var Background: RGBColor;									{Background color												}
							var Border: RGBColor;											{Border's color														}
							var Hilite: RGBColor;												{Highlight color													}
							var Shadow: RGBColor;											{Shadow color for panels										}
							var TextShadow: RGBColor;									{Shadow color for text											}
							var TextHeavyShadow: RGBColor);						{Heavy shadow color for text								}

{Set custom panel colors adopted by new panels}
	procedure SetCustomPanelColors (Text: RGBColor;						{Text color															}
							Background: RGBColor;											{Background color												}
							Border: RGBColor;													{Border's color														}
							Hilite: RGBColor;														{Highlight color													}
							Shadow: RGBColor;												{Shadow color for panels										}
							TextShadow: RGBColor;											{Shadow color for text											}
							TextHeavyShadow: RGBColor);								{Heavy shadow color for text								}

{Set custom panel colors adopted by new panels}
	procedure GetCustomPanelColors (var Text: RGBColor;				{Text color															}
							var Background: RGBColor;									{Background color												}
							var Border: RGBColor;											{Border's color														}
							var Hilite: RGBColor;												{Highlight color													}
							var Shadow: RGBColor;											{Shadow color for panels										}
							var TextShadow: RGBColor;									{Shadow color for text											}
							var TextHeavyShadow: RGBColor);						{Heavy shadow color for text								}

{Delete a panel}
	procedure DeletePanel (Panel: integer);											{Panel number														}

{Delete a panel without removing its image}
	procedure KillPanel (Panel: integer);												{Panel number														}

{Get a panel's co-ordinates}
	procedure GetPanelRect (Panel: integer;										{Panel number														}
							var Bounds: rect);													{Enclosing rectangle co-ordinates (local)			}

{Hide or show a panel}
	procedure PanelDisplay (Panel: integer;										{Panel number														}
							Show: boolean);														{Should the panel be shown?								}

{Hide panel but do not remove the image on the window}
	procedure ObscurePanel (Panel: integer);										{Panel number														}

{Set a panel's colors}
	procedure SetPanelColors (Panel: integer;									{Panel number														}
							Text: RGBColor;														{Text color															}
							Background: RGBColor;											{Background color												}
							Border: RGBColor;													{Border's color														}
							Hilite: RGBColor;														{Highlight color													}
							Shadow: RGBColor;												{Shadow color for panels										}
							TextShadow: RGBColor);										{Shadow color for text											}

{Get a panel's colors}
	procedure GetPanelColors (Panel: integer;									{Panel number														}
							var Text: RGBColor;												{Text color															}
							var Background: RGBColor;									{Background color												}
							var Border: RGBColor;											{Border's color														}
							var Hilite: RGBColor;												{Highlight color													}
							var Shadow: RGBColor;											{Shadow color for panels										}
							var TextShadow: RGBColor);									{Shadow color for text											}

{Move a panel to a new location}
	procedure MovePanel (Panel: integer;											{Panel number														}
							toHoriz: integer;														{Horizontal position in local co-ordinates			}
							toVert: integer);														{Vertical position in local co-ordinates				}

{Move a panel's co-ordinates to a new location without moving the image}
	procedure OffsetPanel (Panel: integer;											{Panel number														}
							distHoriz, distVert: integer);									{Number of pixels to be offset (horiz/vert)			}

{Change a panel's size}
	procedure SizePanel (Panel: integer;												{Panel number														}
							width: integer;															{New width in pixels												}
							height: integer);														{New height in pixels											}

{Change a panel's co-ordinates (size and/or location)}
	procedure MoveSizePanel (Panel: integer;									{Panel number														}
							left, top, right, bottom: integer);								{Enclosing rectangle co-ordinates (local)			}


{Change a panel's co-ordinates (size and/or location,  co-ordinates specified as a 'rect') }
	procedure MoveSizePanelRect (Panel: integer;								{Panel number														}
							Bounds: rect);															{Enclosing rectangle co-ordinates (local)			}

{Specify which sides of a panel are automatically altered when the window is resized}
	procedure AutoMoveSizePanel (Panel: integer;								{Panel number														}
							left: boolean;															{Panel's left side tracks windows right edge		}
							top: boolean;															{Panel's top tracks windows bottom edge			}
							right: boolean;															{Panel's right side tracks windows right edge		}
							bottom: boolean);													{Panel's bottom tracks windows bottom edge		}



{========================================= M E N U S ==========================================}
{Create the "Apple" menu}
	procedure AppleMenu (AboutName: string);									{Optional "About" name									}

{Declare that a 'Select All' item exists in the Edit menu}
	procedure SetSelectAllItem (ItemNumber: integer);						{Item number within the Edit menu (0=n/a)			}

{Create a menu name, add/change a menu item, or rename an existing menu item (pull-down & hierarchical menus)}
	procedure Menu (MenuNumber: integer;											{Menu number														}
							ItemNumber: integer;												{Item number within the menu								}
							EnabledFlag: boolean;											{Enable the menu?												}
							MenuText: string);													{Menu title or item name										}

{Attach a hierarchical menu to a menu item, or detach a hierarchical menu}
	procedure AttachMenu (MenuNumber: integer;								{Menu number to which the submenu is attached}
							ItemNumber: integer;												{Item number to which the submenu is attached	}
							SubMenuNumber: integer);										{Hierarchical menu number being attached			}

{Insert a menu item}
	procedure InsertMenuItm (MenuNumber: integer;							{Menu number														}
							ItemNumber: integer;												{Item number where insertion is to be made		}
							EnabledFlag: boolean;											{Enable the menu?												}
							MenuText: string);													{Item name															}

{Insert resource names in a menu}
	procedure ResNamesToMenu (MenuNumber: integer;					{Menu number														}
							ItemNumber: integer;												{Item number where insertion is to be made		}
							rType: ResType);													{Resource type													}

{Remove an entire menu and its associated items, or a menu item}
	procedure RemoveMenu (MenuNumber: integer;							{Menu number														}
							ItemNumber: integer);												{Item number within the menu (0=entire menu)	}

{Delete all application menus in the menu bar (except Apple Menu)}
	procedure RemoveMenus;

{Delete all application menus in the menu bar (except Apple menu) and all hierarchical menus}
	procedure RemoveAllMenus;

{Display the menu bar after making changes through the Menu or RemoveMenu procedure}
	procedure UpdateMenuBar;

{Hide or show the menu bar}
	procedure MenuBarDisplay (Show: boolean);									{Should the menu bar be shown?						}

{Get a menu item's text}
	procedure GetMenuString (MenuNumber: integer;							{Menu number														}
							ItemNumber: integer;												{Item number within the menu								}
							var MenuText: Str255);											{Menu item's name												}

{Change the name of a menu item}
	procedure RenameItem (MenuNumber: integer;								{Menu number														}
							ItemNumber: integer;												{Item number within the menu								}
							MenuText: string);													{Menu item's name												}

{Enable/disable a menu or menu item}
	procedure EnableMenu (MenuNumber: integer;								{Menu number														}
							ItemNumber: integer;												{Item number within the menu (or 0)					}
							EnabledFlag: boolean);											{Enable the menu or item?									}

{Display/remove a menu item's check mark}
	procedure CheckMenu (MenuNumber: integer;								{Menu number														}
							ItemNumber: integer;												{Item number within the menu								}
							checked: boolean);													{Place check mark beside the menu item?			}

{Mark a menu item with a specified character ( or , etc)}
	procedure MenuMark (MenuNumber: integer;									{Menu number														}
							ItemNumber: integer;												{Item number within the menu								}
							markChar: char);														{Menu item's character										}

{Get a menu item's mark character ( or , etc) which is optionally displayed at the item's left side}
	procedure GetMenuMark (MenuNumber: integer;							{Menu number														}
							ItemNumber: integer;												{Item number within the menu								}
							var markChar: char);												{Menu item's character										}

{Specify a keyboard equivalent for a menu item}
	procedure MenuCmd (MenuNumber: integer;									{Menu number														}
							ItemNumber: integer;												{Item number within the menu								}
							cmdChar: char);														{Menu item's keyboard-equivalent character		}

{Get a keyboard equivalent for a menu item}
	procedure GetMenuCmd (MenuNumber: integer;							{Menu number														}
							ItemNumber: integer;												{Item number within the menu								}
							var cmdChar: char);												{Menu item's keyboard-equivalent character		}

{Specify an icon to be displayed by a menu item}
	procedure MenuIcon (MenuNumber: integer;									{Menu number														}
							ItemNumber: integer;												{Item number within the menu								}
							IconSelector: integer);											{IconSelector + 256 = Icon ID number					}

{Get the specifier for the icon that is displayed by a menu item}
	procedure GetMenuIcon (MenuNumber: integer;							{Menu number														}
							ItemNumber: integer;												{Item number within the menu								}
							var IconSelector: integer);										{IconSelector + 256 = Icon ID number					}

{Set the character style for a menu item}
	procedure MenuStyle (MenuNumber: integer;								{Menu number														}
							ItemNumber: integer;												{Item number within the menu								}
							theStyle: Style);														{Menu item's character style								}

{Determine the number of items in a menu}
	function MenuItemCount (MenuNumber: integer							{Menu number														}
							): integer;																	{Number of items in the menu								}

{Determine a menu's parent menu number}
	procedure GetParentMenu (var MenuNumber: integer;					{Parent menu's menu number								}
							var ItemNumber: integer;										{Parent menu's item number								}
							SubMenuNumber: integer);										{Menu number whose parent menu is determined}

{Determine a menu item's submenu number}
	procedure GetSubMenu (MenuNumber: integer;							{Menu number														}
							ItemNumber: integer;												{Item number within the menu								}
							var SubMenuNumber: integer);								{Menu number of this item's submenu					}

{Highlight a menu in the menu bar, or turn off menu bar highlights}
	procedure MenuHilite (MenuNumber: integer);								{Menu num for a pull-down menu (1-15, 0=none)	}



{==================================== P O P - U P   M E N U S =====================================}
{Create a new Pop-Up menu}
	procedure NewPopUp (MenuNumber: integer;								{Pop-Up Menu number											}
							left, top, right, bottom: integer;								{Enclosing rectangle co-ordinates (local)			}
							MenuTitle: string;													{Title																	}
							Spec: longint;															{Appearance & Behavior specifications				}
							EnabledFlag: boolean);											{"Menu is enabled" flag										}

{Create a new Pop-Up menu (co-ordinates specified as a 'rect') }
	procedure NewPopUpRect (MenuNumber: integer;						{Pop-Up Menu number											}
							Bounds: rect;															{Enclosing rectangle co-ordinates (local)			}
							MenuTitle: string;													{Title																	}
							Spec: longint;															{Appearance & Behavior specifications				}
							EnabledFlag: boolean);											{"Menu is enabled"  flag										}

{Add or change a Pop-Up menu item, or rename an existing menu item}
	procedure PopUpMenu (MenuNumber: integer;								{Pop-Up Menu number											}
							ItemNumber: integer;												{Item number within the menu								}
							EnabledFlag: boolean;											{Enable the menu?												}
							MenuText: string);													{Item name															}

{Insert a Pop-Up menu item}
	procedure InsertPopUpItem (MenuNumber: integer;						{Pop-Up Menu number											}
							ItemNumber: integer;												{Item number where insertion is to be made		}
							EnabledFlag: boolean;											{Is menu item enabled?										}
							MenuText: string);													{Item name															}

{Insert resource names in a Pop-Up menu}
	procedure ResNamesToPopUp (MenuNumber: integer;					{Pop-Up Menu number											}
							ItemNumber: integer;												{Item number where insertion is to be made		}
							rType: ResType);													{Resource type													}

{Remove an Pop-Up menu, or a Pop-Up menu item}
	procedure RemovePopUp (MenuNumber: integer;							{Pop-Up Menu number											}
							ItemNumber: integer);												{Item number within the menu (0=entire menu)	}

{Delete all items in a Pop-Up menu}
	procedure ClearPopUp (MenuNumber: integer);								{Pop-Up Menu number											}

{Delete a pop-up menu without removing its image}
	procedure KillPopUp (MenuNumber: integer);									{Pop-Up menu number											}

{Get a pop-up menu's co-ordinates}
	procedure GetPopUpRect (MenuNumber: integer;							{Pop-Up menu number											}
							var Bounds: rect);													{Enclosing rectangle co-ordinates (local)			}

{Hide or show a Pop-Up menu}
	procedure PopUpDisplay (MenuNumber: integer;							{Pop-Up Menu number											}
							Show: boolean);														{Should the Pop-Up Menu be shown?					}

{Hide Pop-Up menu but do not remove the image on the window}
	procedure ObscurePopUp (MenuNumber: integer);						{Pop-Up Menu number											}

{Get an Pop-Up Menu item's text}
	procedure GetPopUpString (MenuNumber: integer;						{Pop-Up Menu number											}
							ItemNumber: integer;												{Item number within the menu								}
							var MenuText: Str255);											{Menu item's name												}

{Change the name of a Pop-Up Menu item}
	procedure RenamePopUp (MenuNumber: integer;							{Pop-Up Menu number											}
							ItemNumber: integer;												{Item number within the menu								}
							MenuText: string);													{Menu item's name												}

{Enable/disable a Pop-Up Menu or menu item}
	procedure EnablePopUp (MenuNumber: integer;							{Pop-Up Menu number											}
							ItemNumber: integer;												{Item number within the menu (or 0)					}
							EnabledFlag: boolean);											{Enable the menu or item?									}

{Determine if a Pop-Up Menu is enabled}
	function PopUpIsEnabled (MenuNumber: integer							{Pop-Up Menu number											}
							): boolean;																{Is the menu enabled?											}

{Display/remove a Pop-Up Menu item's check mark}
	procedure CheckPopUp (MenuNumber: integer;							{Pop-Up Menu number											}
							ItemNumber: integer;												{Item number within the menu								}
							checked: boolean);													{Place check mark beside the menu item?			}

{Mark a Pop-Up Menu item with a specified character ( or , etc)}
	procedure PopUpMark (MenuNumber: integer;								{Pop-Up Menu number											}
							ItemNumber: integer;												{Item number within the menu								}
							markChar: char);														{Menu item's character										}

{Get a Pop-Up Menu item's mark character ( or , etc) which is optionally displayed at the item's left side}
	procedure GetPopUpMark (MenuNumber: integer;							{Pop-Up Menu number											}
							ItemNumber: integer;												{Item number within the menu								}
							var markChar: char);												{Menu item's character										}

{Specify an icon to be displayed by a Pop-Up Menu item}
	procedure PopUpIcon (MenuNumber: integer;								{Pop-Up Menu number											}
							ItemNumber: integer;												{Item number within the menu								}
							IconSelector: integer);											{IconSelector + 256 = Icon ID number					}

{Get the specifier for the icon that is displayed by a Pop-Up Menu item}
	procedure GetPopUpIcon (MenuNumber: integer;							{Pop-Up Menu number											}
							ItemNumber: integer;												{Item number within the menu								}
							var IconSelector: integer);										{IconSelector + 256 = Icon ID number					}

{Set the character style for a Pop-Up Menu item}
	procedure PopUpStyle (MenuNumber: integer;								{Pop-Up Menu number											}
							ItemNumber: integer;												{Item number within the menu								}
							theStyle: Style);														{Menu item's character style								}

{Determine the number of items in a Pop-Up Menu}
	function PopUpItemCount (MenuNumber: integer							{Pop-Up Menu number											}
							): integer;																	{Number of items in the menu								}

{Determine the selected item in a Pop-Up Menu}
	function GetPopUpSelection (MenuNumber: integer						{Pop-Up Menu number											}
							): integer;																	{Selected item in the menu									}

{Move a pop-up menu to a new location}
	procedure MovePopUp (MenuNumber: integer;								{Pop-Up menu number											}
							toHoriz: integer;														{Horizontal position in local co-ordinates			}
							toVert: integer);														{Vertical position in local co-ordinates				}

{Move a pop-up menu's co-ordinates to a new location without moving the image}
	procedure OffsetPopUp (MenuNumber: integer;							{Pop-Up menu number											}
							distHoriz, distVert: integer);									{Number of pixels to be offset (horiz/vert)			}

{Change a pop-up menu's size}
	procedure SizePopUp (MenuNumber: integer;								{Pop-Up menu number											}
							width: integer);														{New width in pixels												}

{Change a pop-up menu's co-ordinates (size and/or location)}
	procedure MoveSizePopUp (MenuNumber: integer;						{Pop-Up menu number											}
							left, top, right, bottom: integer);								{Enclosing rectangle co-ordinates (local)			}

{Change a pop-up menu's co-ordinates (size and/or location,  co-ordinates specified as a 'rect') }
	procedure MoveSizePopUpRect (MenuNumber: integer;				{Pop-Up menu number											}
							Bounds: rect);															{Enclosing rectangle co-ordinates (local)			}

{Specify which sides of a pop-up menu are automatically moved when the window is resized}
	procedure AutoMoveSizePopUp (MenuNumber: integer;				{Pop-Up menu number											}
							left: boolean;															{Menu's left side tracks window's right edge		}
							top: boolean;															{Menu's top/bottom track window's bottom edge}
							right: boolean);														{Menu's right side tracks window's right edge		}



{======================================= C U R S O R S  ========================================	}
{Change the cursor shape}
	procedure CursorShape (CursorType: integer);								{Cursor type														}

{Reset the cursor to its appropriate shape depending on its location in the active window}
	procedure ResetCursor;

{Set the cursor animation sequence																							[Developer Kit bonus]	}
	procedure SetCursorAnimation (acurResID: integer);					{'acur' (cursor animation) resource ID					}

{Force cursor animation																												[Developer Kit bonus]	}
	procedure AnimateCursor;

{Create a new Cursor Table}
	procedure NewCursorTable (CursorTable: integer;							{Cursor table number											}
							CursorType: integer);												{Cursor type														}

{Delete a Cursor Table}
	procedure DeleteCursorTable (CursorTable: integer);					{Cursor table number											}

{Add a new Cursor Zone to a Cursor Table, or replace an existing Cursor Zone}
	procedure CursorZone (CursorTable: integer;								{Cursor table number											}
							Zone: integer;															{Cursor zone number											}
							CursorType: integer;												{Cursor type														}
							left, top, right, bottom: integer);								{Cursor zone's co-ordinates (local)						}

{Add a new Cursor Zone to a Cursor Table, or replace an existing Cursor Zone (co-ordinates specified as a 'rect') }
	procedure CursorZoneRect (CursorTable: integer;							{Cursor table number											}
							Zone: integer;															{Cursor zone number											}
							CursorType: integer;												{Cursor type														}
							ZoneRect: rect);														{Cursor zone's co-ordinates (local)						}

{Add a new Cursor Zone to a Cursor Table, or replace an existing Cursor Zone (co-ordinates specified as a 'region') }
	procedure CursorZoneRgn (CursorTable: integer;							{Cursor table number											}
							Zone: integer;															{Cursor zone number											}
							CursorType: integer;												{Cursor type														}
							ZoneRgn: RgnHandle);											{Cursor zone's region (local)								}

{Indicate that the cursor shape may have to be recalculated due to manually altering Cursor Zone regions}
	procedure ChangedCursorZone;

{Delete a Cursor Zone}
	procedure DeleteCursorZone (CursorTable: integer;						{Cursor table number											}
							Zone: integer);															{Cursor zone number											}

{Get the bounding rectangle of a specified Cursor Zone}
	procedure GetCursorZone (CursorTable: integer;							{Cursor table number											}
							Zone: integer;															{Cursor zone number											}
							var ZoneRect: rect);												{Cursor zone's bounding rectangle						}

{Get a handle to a specified Cursor Zone's region}
	function GetCursorZoneRgn (CursorTable: integer;						{Cursor table number											}
							Zone: integer															{Cursor zone number											}
							): RgnHandle;															{Handle to Cursor zone's region							}

{Make the current window use a specified Cursor Table}
	procedure UseCursorTable (CursorTable: integer);						{Cursor table number											}

{Find the cursor zone that contains a specified point}
	function FindCursorZone (thePoint: point										{Location in window's local co-ordinates				}
							): integer;																	{Cursor zone number containing the point			}

{Change the cursor shape for a Cursor Table or a Cursor Zone}
	procedure SetCursorZoneCurs (CursorTable: integer;					{Cursor table number											}
							Zone: integer;															{Cursor zone number (0 = Cursor Table default)	}
							CursorType: integer);												{Cursor type														}

{Determine which Cursor Zone contains the cursor}
	procedure GetCurrentCursorZone (var Window: integer;				{Window number													}
							var CursorTable: integer;										{Cursor table number											}
							var Zone: integer);													{Cursor zone number (0 = Cursor Table default)	}

{Enable/disable clicks on push-buttons when the watchCursor is displayed}
	procedure WatchCursorButtons (Allowed: boolean);						{Can push-buttons be clicked when the				}
																											{	watchCursor is displayed?								}



{======================================== P O L L I N G =========================================}
{Tools Plus polling procedure}
	function PollSystem (var UserPoll: TPPollRecord							{Polling record														}
							): boolean;																{Did an event occurred?										}

{Set the number of ticks (1/60 sec) your application can wait until it receives a doNothing event}
	procedure SetNullTime (ActiveTime: longint;									{Duration active application								}
							SuspendedTime: longint);										{Duration suspended application						}

{Determine if "waiting for doNothing events" (timed doNothing events) is supported}
	function WaitAvail: boolean;															{Is waiting between doNothing events supported?}

{Determine if your application is 'suspended' (i.e. this is not the active application)}
	function ApplicationSuspended: boolean;										{Is your application suspended?							}

{Wait for subsequent clicks in a multiple click sequence?}
	procedure WaitForMultiClicks (WaitFlag: boolean);						{Wait for subsequent events?								}

{Clear the mouse's current click or drag (i.e. discontinue the process, clear the event) }
	procedure ResetMouseClicks;

{Ignore the first mouse click of a multi-click sequence}
	procedure IgnoreFirstMouseClick;



{==================================== C O L O R   D R A W I N G ===================================}
{Determine if the Macintosh has Color QuickDraw}
	function HasColorQuickDraw: boolean;											{Does the Mac have Color QuickDraw?				}

{Determine the number of logical screens (distinct screen depth and color/gray settings)}
	function NumberOfScreens: integer;												{Number of logical screens available					}

{Begin updating the specified logical screen}
	procedure BeginUpdateScreen (TheScreen: integer);					{Logical screen number										}

{End updating the most recent logical screen}
	procedure EndUpdateScreen;

{Determine the logical screen's depth}
	function ScreenDepth: integer;														{Screen depth in bits											}

{Determine if the logical screen is set to display in color}
	function ScreenHasColors: boolean;												{Is the screen set to display in color?					}

{Determine if a rectangle is in a window's visible region}
	function RectIsVisible (TheRect: rect												{Rectangle in window's local coordinates			}
							): boolean;																{Is the rectangle in the window's visible region?	}

{Determine if a known region is in a window's visible region}
	function RgnIsVisible (TheRgn: rgnHandle										{Region handle in window's local coordinates		}
							): boolean;																{Is the region in the window's visible region?		}

{Get the current port's foreground color}
	procedure GetFrontRGB (var Color: RGBColor);							{Current port's foreground RGB color					}

{Get the current port's background color}
	procedure GetBackRGB (var Color: RGBColor);							{Current port's background RGB color				}

{Set the current port's foreground color}
	procedure SetFrontRGB (Color: RGBColor);									{Current port's new foreground RGB color			}

{Set the current port's background color}
	procedure SetBackRGB (Color: RGBColor);									{Current port's new background RGB color			}

{Store a color's components in a color record}
	procedure SetRGB (var Color: RGBColor;										{RGB color record being set								}
							Red: longint;															{Color's red component										}
							Green: longint;														{Color's green component									}
							Blue: longint);															{Color's blue component										}

{Erase a rectangle using the window's backdrop color and invalidate it}
	procedure RedrawRect (TheRect: rect);											{Rectangle in window's local coordinates			}

{Erase a region using the window's backdrop color and invalidate it}
	procedure RedrawRgn (TheRgn: RgnHandle);								{Region handle in window's local coordinates		}

{Calculate a 'disabled' color}
	function GetDimColor (Front: RGBColor;										{Foreground object's color (being disabled)		}
							Back: RGBColor;														{Background color												}
							var DimColor: RGBColor											{Foreground object's disabled color					}
							): boolean;																{Is a disabled color available (dither if not avail.)}

{Set the foreground color to the system's highlight color, and the background to white}
	procedure UseHiliteColor;

{Set the text drawing mode for writing on the highlight color}
	procedure UseHiliteText;

{Highlight or unhighlight a rectangle and set the text drawing mode for writing in the area}
	procedure HiliteRect (TheRect: Rect;												{Rectangle that is (un)highlighted						}
							Hilite: boolean);														{Is the rectangle's area highlighted?					}

{Highlight or unhighlight a region and set the text drawing mode for writing in the area}
	procedure HiliteRgn (TheRgn: RgnHandle;										{Region that is (un)highlighted							}
							Hilite: boolean);														{Is the region's area highlighted?						}

{Color equivalent to 'PenNormal' routine}
	procedure PenColorNormal;

{Color equivalent to 'GetPenState' routine}
	procedure GetColorPenState (var ThePenState: ColorPenState);{Pen settings														}

{Color equivalent to 'SetPenState' routine}
	procedure SetColorPenState (ThePenState: ColorPenState);		{Pen settings														}



{================================= U S E R    N O T I F I C A T I O N =================================	}
{Define the settings for the Notification Manager}
	procedure SetNotification (IconID: integer;									{'SICN' icon ID displayed during notification		}
							SoundID: integer;													{Sound ID that is played at notification				}
							Message: string;														{Message displayed during notification				}
							ResetAfterUse: boolean);										{Revert settings to defaults after notification?	}

{If this application is inactive, inform user that this application needs attention}
	function PostNotification: boolean;												{Was the user notified?										}



{=================================== D Y N A M I C   A L E R T S ===================================	}
{Display a dynamic Alert Box and return the use's action}
	function AlertBox (theIcon: integer;												{Icon ID number													}
							AlertText: string;														{Alert's text															}
							AlertCode: longint													{Button setup code												}
							): integer;																	{Button clicked by user										}

{Display a dynamic Alert Box (using temporary button names) and return the use's action}
	function AlertBox3 (theIcon: integer;												{Icon ID number													}
							AlertText: string;														{Alert's text															}
							AlertCode: longint;													{Button setup code												}
							But1, But2, But3: string											{Temporary names for buttons 1,2 and 3			}
							): integer;																	{Button clicked by user										}

{Change a button name for the next use of the dynamic Alert Box}
	procedure AlertButtonName (Button: integer;								{Button number from 1 to 9									}
							Title: string);															{Button's title														}

{Enable or disable menus when a dynamic "Alert Box" is displayed}
	procedure AlertBoxMenus (EnableFlag: boolean);							{Leave menus enabled when alert is shown?		}



{==========================  S T R #   S T R U C T U R E   M A I N T E N A N C E  =========================	}
{Create a new Indexed String record (identical to 'STR#' resource) }
	function NewIndexStringHandle (NumberOfStrings: integer			{Number of strings in record								}
							): Handle;																	{Handle to Indexed String record						}

{Determine the number of strings in an Indexed String record}
	function CountIndexString (hRec: Handle										{Handle to Indexed String record						}
							): integer;																	{Number of strings in the Indexed String record	}

{Get a string from an Indexed String record}
	procedure GetIndexString (hRec: Handle;										{Handle to Indexed String record						}
							Index: integer;															{Element number being retrieved						}
							var Text: Str255);													{String retrieved from specified index positon	}

{Save a string in an Indexed String record}
	procedure SetIndexString (hRec: Handle;										{Handle to Indexed String record						}
							Index: integer;															{Element number being updated							}
							Text: string);															{New string value													}

{Insert a string into an Indexed String record}
	procedure InsertIndexString (hRec: Handle;									{Handle to Indexed String record						}
							Index: integer;															{Element number where new string is inserted	}
							Text: string);															{Newly inserted string											}

{Delete a string from an Indexed String record}
	procedure DeleteIndexString (hRec: Handle;									{Handle to Indexed String record						}
							Index: integer);														{Element number where string is deleted			}



{========================  O f f   S c r e e n   B i t   M a p s   a n d   P i x e l   M a p s  =======================	}
{Create an offscreen bitmap (or pixmap) and make it the current grafPtr}
	function CreateBitMap (var newPort: GrafPtr;								{Returned pointer to new offscreen bitmap			}
							var hGDevice: GDHandle;										{Returned handle to graphics device					}
							Bounds: rect;															{Bitmap's bounding rect, window's local co-ords}
							TypeOfMap: integer												{Type of bitmap created										}
							): boolean;																{Was Bitmap successfully created?					}

{Destroy an offscreen bitmap (or pixMap)}
	procedure DestroyBitMap (oldOffscreen: GrafPtr);						{Pointer to old offscreen bitmap							}

{Convert a BitMap or PixMap to a region (works on all systems) }
	function BitMap2Region (Region: RgnHandle;								{Valid region handle												}
							bMap: BitMap															{BitMap or 1-bit deep PixMap								}
							): OSErr;																	{OS Error code													}



{==================================== M I S C E L L A N E O U S ===================================}
{Draw a string in a specified rectangle}
	procedure StrInBox (left, top, right, bottom: integer;						{Enclosing view rectangle co-ordinates (local)	}
							Text: string;																{String being displayed										}
							DispSpec: longint;													{Display specifications										}
							Just: integer);															{Justification: left,centre,right => 0,1,-1				}

{Draw a string in a specified rectangle (co-ordinates specified as a 'rect') }
	procedure StrInBoxRect (Bounds: rect;											{Enclosing view rectangle co-ordinates (local)	}
							Text: string;																{String being displayed										}
							DispSpec: longint;													{Display specifications										}
							Just: integer);															{Justification: left,centre,right => 0,1,-1				}

{Draw text in a specified rectangle}
	procedure TextInBox (left, top, right, bottom: integer;					{Enclosing view rectangle co-ordinates (local)	}
							TextPtr: Ptr;															{Pointer to text being displayed							}
							Length: integer;														{Number of characters being displayed				}
							DispSpec: longint;													{Display specifications										}
							Just: integer);															{Justification: left,centre,right => 0,1,-1				}

{Draw text in a specified rectangle (co-ordinates specified as a 'rect') }
	procedure TextInBoxRect (Bounds: rect;										{Enclosing view rectangle co-ordinates (local)	}
							TextPtr: Ptr;															{Pointer to text being displayed							}
							Length: integer;														{Number of characters being displayed				}
							DispSpec: longint;													{Display specifications										}
							Just: integer);															{Justification: left,centre,right => 0,1,-1				}

{Determine the System file version}
	function SystemVersion: extended;												{System file version (eg: 7.0.1 returned as 7.01)}

{Draw a picture ('PICT' resource) }
	procedure DrawPict (BaseID: integer;											{Base PICT ID number											}
							left, top, right, bottom: integer;								{Enclosing view rectangle co-ordinates (local)	}
							DispSpec: longint);													{Display specifications										}

{Draw a picture (co-ordinates specified as a 'rect') }
	procedure DrawPictRect (BaseID: integer;										{Base PICT ID number											}
							Bounds: rect;															{Destination rectangle co-ordinates (local)			}
							DispSpec: longint);													{Display specifications										}

{Draw a picture shifted within a rectangle}
	procedure DrawShiftPict (BaseID: integer;										{Base PICT ID number											}
							left, top, right, bottom: integer;								{Enclosing view rectangle co-ordinates (local)	}
							dh, dv: integer;														{Number of pixels to be offset (horiz/vert)			}
							DispSpec: longint);													{Display specifications										}

{Draw a picture shifted within a rectangle (co-ordinates specified as a 'rect') }
	procedure DrawShiftPictRect (BaseID: integer;								{Base PICT ID number											}
							Bounds: rect;															{Destination rectangle co-ordinates (local)			}
							dh, dv: integer;														{Number of pixels to be offset (horiz/vert)			}
							DispSpec: longint);													{Display specifications										}

{Draw an icon (ICON, ICN#, icl8, icl4, cicn, ics#, ics8, ics4,SICN)}
	procedure DrawIcon (theIcon: integer;											{Icon ID number													}
							left, top: integer;														{Icon's top-left corner in window's local co-ord.	}
							EnabledFlag, SelectedFlag: boolean);					{Enable the icon?  Select the icon?						}

{Draw an SICN icon (srcCopy mode used) }
	procedure DrawSICN (theIcon: integer;											{SICN ID number													}
							left, top: integer;														{Icon's top-left corner in window's local co-ord.	}
							index: integer);														{Image number in SICN resource						}

{Draw an SICN icon (any copy mode) }
	procedure DrawSICNmode (theIcon: integer;									{SICN ID number													}
							left, top: integer;														{Icon's top-left corner in window's local co-ord.	}
							index: integer;															{Image number in SICN resource						}
							mode: integer);														{Copying mode (srcOr, srcCopy, etc.)				}

{Specify the default appearance for disabled icons}
	procedure DefaultIconLook (IconSpec: longint);							{Appearance specifications								}

{Draw a standard Macintosh progress thermometer}
	procedure DrawThermometer (DisplayRect: rect;							{Thermometer's co-ordinates (local)					}
							Value: longint;															{Current value														}
							Maximum: longint);													{Maximum value (progress = Value  Maximum)	}

{Draw "zoom" lines (expanding/collapsing rectangle)}
	procedure ZoomLines (OldRect: Rect;											{Starting rectangle (global co-ordinates)			}
							NewRect: Rect;														{Ending rectangle (global co-ordinates)				}
							Zoom: integer);														{Zoom across, in, or out										}

{Play the System Error sound}
	procedure Beep;

{Wait for a specified duration}
	procedure Wait (ClockTicks: longint);												{Number of ticks (1/60th sec) to wait					}

{Synchronize to video (wait until vertical retrace occurs before continuing) }
	procedure SynchToVideo;

{Set all bytes in a record to zero (0) }
	procedure SetToZero (RecPtr: Ptr;													{Pointer to record being zeroed							}
							RecSize: longint);													{Size of record in bytes										}

{Determine if two memory blocks contain equal data.}
	function EqualMem (Ptr1: Ptr;															{Pointer to 1st memory block								}
							Ptr2: Ptr;																	{Pointer to 2nd memory block								}
							BytesToCheck: longint											{Number of bytes being compared						}
							): boolean;																{Are the two blocks equal?									}

{Determine the minimum value of 2 numbers}
	function min (Val1, Val2: longint): longint;

{Determine the maximum value of 2 numbers}
	function max (Val1, Val2: longint): longint;

{Get the Tools Plus version number}
	procedure GetToolsPlusVersion (var Version: Str255);					{Tools Plus version number returned					}

{PRIVATE:	This function obtains the System file's version number as an integer for the SystemVersion function}
	function _SYSV: integer;



{=============================  M u l t i p l e   L a n g u a g e   S u p p o r t  ==============================}
{Select an STR# resource to replace Tools Plus text}
	procedure ToolsPlusLanguage (ResID: integer);							{STR# resource containing replacement strings	}





implementation

{The SystemVersion function returns the System File's version as an 'extended' type floating-point number.  This	}
{source code, when compiled, will produce an appropriate 'extended' type floating-point number whose format is		}
{determined by your compiler's settings (ie: Compiled for a math co-processor, 68040, or not)									}
	function SystemVersion;
	begin
		SystemVersion := _SYSV / 100;													{Get System Version and convert to an				}
	end;																									{	extended type.												}


{$ALIGN RESET}
{$POP}
end.