{	Tools Plus Tutorial	- -	Hello World!	}

{	NOTE:	}
{	The MWERKS compiler directived ($IFC MWERKS) indicates code that is compiled only by	}
{	the CodeWarrior compiler.  THINK Pascal and Metrowerks CodeWarrior Pascal have	}
{	_slight_ differences, and this compiler directive lets you use one source for both compilers.	}
{	You can remove the code that does not pertain to your compiler.	}


program Tutorial;
	uses
{$IFC MWERKS}
		Dialogs, Fonts, Processes, SegLoad, TextEdit, ToolsPlus, Windows;
{$ELSEC}
		ToolsPlus;
{$ENDC}


	var
		Poll: TPPollRecord;			{Polling record to retrieve event information}
		ExitTheDemo: boolean;		{Should the demo terminate?}




{	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	}
	procedure ProcessMenuSelection;
		const
			NewItem = 1;
			OpenItem = 2;
			CloseItem = 3;
			QuitItem = 5;
		var
			theButton: integer;
	begin

		case Poll.Menu.Num of
			mAppleMenu: 	{Apple menu's 'About' item}
				theButton := AlertBox(NoIcon, 'This is my applications about box.  (Click to close)', NoButtonAlert);

			mFileMenu: 
				case Poll.Menu.Item of
					NewItem: 
						;
					OpenItem: 
						;
					CloseItem: 
						;
					QuitItem: 
						ExitTheDemo := true;
				end
		end;

		MenuHilite(0);	{Turn off highlighted menu}
	end;



{	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	}
	procedure DrawWindowContents;
	begin
	{	Draw the contents of a window.  It's good to have this code in a separate routine because you	}
	{	need to use it [1] when a window is first opened, and [2] when a window needs to be refreshed.	}

		CurrentWindow(1);		{Subsequent drawing takes place on this window (current grafPort)	}
		TextFont(systemFont);
		TextSize(36);
		MoveTo(90, 140);
		DrawString('Hello World!');
	end;


{	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	}
	procedure ApplicationInitialization;
		const
			DemoWindow1 = 1;
	begin
	{	Do all the application setup before you start polling for events	}

	{Create an Apple menu with an 'About' item}
		AppleMenu('About My App');

	{Create the standard File and Edit menus}
		Menu(mFileMenu, 0, enabled, 'File');
		Menu(mFileMenu, 1, disabled, 'New/N');
		Menu(mFileMenu, 2, disabled, 'Open/O');
		Menu(mFileMenu, 3, disabled, 'Close/W');
		Menu(mFileMenu, 4, disabled, mDividingLine);
		Menu(mFileMenu, 5, enabled, 'Quit/Q');

		Menu(mEditMenu, 0, enabled, 'Edit');
		Menu(mEditMenu, 1, disabled, 'Undo/Z');
		Menu(mEditMenu, 2, disabled, mDividingLine);
		Menu(mEditMenu, 3, disabled, 'Cut/X');
		Menu(mEditMenu, 4, disabled, 'Copy/C');
		Menu(mEditMenu, 5, disabled, 'Paste/V');
		Menu(mEditMenu, 6, disabled, 'Clear');
		Menu(mEditMenu, 7, disabled, mDividingLine);
		Menu(mEditMenu, 8, disabled, 'Show Clipboard');

		WindowOpen(DemoWindow1, 5, 40, 425, 320, 'Hello World Tutorial', documentProc, GoAway, NotModal);
		DrawWindowContents;
		ExitTheDemo := false;
	end;


{	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	}
begin
{$IFC MWERKS}
{Toolbox initialization - - Done automatically by THINK Pascal}
	InitGraf(@qd.thePort);
	InitFonts;
	InitWindows;
	InitMenus;
	TEInit;
	InitDialogs(nil);
{$ENDC}

	if not InitToolsPlus(10, 1, initTE32KBuffer, initUseColor) then
		ExitToShell;

	ApplicationInitialization;

	while not ExitTheDemo do	{Main Event Loop}
		if PollSystem(Poll) then	{If an event is available, process the event}

			case Poll.What of

				doMenu: 
					ProcessMenuSelection;


				doRefresh:		{Part of window needs to be refreshed}
					begin
						BeginUpdate(WindowPointer(Poll.Window));	{Restrict drawing to area that needs it}
						DrawWindowContents;
						EndUpdate(WindowPointer(Poll.Window));		{End the update for the window (unrestricted drawing)}
					end;


				doGoAway:		{User clicked a window's close box}
					WindowClose(Poll.Window);

		{  Other core events we're ignoring in this app}
		{	doButton, doPictButton, doKeyDown, doAutoKey, doClickField,		}
		{	doScrollBar, doListBox, doPopUpMenu, doClick	}

				otherwise	{All other events are ignored}
			end

		else
			begin
		{	If your application has background processing, the code goes here and gets	}
		{	executed each time you call PollSystem and there are no events available.		}
			end;
end.