//	Tools Plus Tutorial -- Tools Bar and Floating Palettes




 #include "ToolsPlus.h"


 #define CloseItem					1
 #define QuitItem						3
 
 

 TPPollRecord		Poll;					// Polling record to retrieve event information
 Boolean				ExitTheDemo;	// Should the demo terminate?



 void ApplicationInitialization (void);






 //	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-
 void main(void)
 {
	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0L);


	if (!InitToolsPlus(10, 6, initTE32KBuffer, initUseColor))
		ExitToShell();

	ApplicationInitialization();

	while (!ExitTheDemo)					//Main Event Loop
		{
		if (PollSystem(&Poll))			//If an event is available, process the event
			{
			switch (Poll.What)
				{
				case doMenu: 
					switch (Poll.Menu.Item)
						{
						case CloseItem:		// Close a window
							// Close stanard wndows first, then palettes
							if (FirstStdWindowNumber() != none)
								WindowClose(FirstStdWindowNumber());
							else
								WindowClose(FirstWindowNumber());
							if (FirstWindowNumber() == none)		// If no windows open
								EnableMenu(mFileMenu, CloseItem, disabled);
							MenuHilite(0);
							break;

						case QuitItem:
							ExitTheDemo = true;
							break;
						}
					break;

				case doGoAway:		// A window's close box was clicked
					WindowClose(Poll.Window);					// Close the clicked window
					if (FirstWindowNumber() == none)	// If no windows are open
						EnableMenu(mFileMenu, CloseItem, disabled);
					break;

				case doChgWindow:	// Activate the clicked window
					ActivateWindow(Poll.Window);
					break;

				default:
					break;			//All other events are ignored
				}
			}
		}
 }



 //	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-
 void ApplicationInitialization (void)
	{
 	#define		StdWindow1		1
 	#define		StdWindow2		2
 	#define		ToolBar				3
 	#define		Palette1			4
 	#define		Palette2			5
 	#define		Palette3			6

	AppleMenu("\p");
	Menu(mFileMenu, 0, enabled, "\pFile");
	Menu(mFileMenu, CloseItem, enabled, "\pClose/W");
	Menu(mFileMenu, 2, disabled, mDividingLine);
	Menu(mFileMenu, QuitItem, enabled, "\pQuit/Q");

	ToolBarOpen(ToolBar, 40, tbOffsetNewWindows);
	WindowOpen(StdWindow1, 0, 0, 230, 160, "\pFirst Standard Window", noGrowDocProc + wTile, GoAway, NotModal);
	WindowOpen(StdWindow2, 0, 0, 230, 160, "\pSecond Standard Window", noGrowDocProc + wTile, GoAway, NotModal);

	WindowOpen(Palette1, 300, 35, 390, 190, "\pPalette1", paletteProc, GoAway, NotModal);
	WindowOpen(Palette2, 320, 55, 410, 210, "\pPalette2", paletteProc, GoAway, NotModal);
	WindowOpen(Palette3, 340, 75, 530, 130, "\p", altPaletteProc, GoAway, NotModal);

	ExitTheDemo = false;
	}