//	Tools Plus Tutorial	- -	Scrolling GUI Elements




 #include "string.h"
 #include "ToolsPlus.h"


 #define bComputer					1			//	picture button numbers
 #define bDisk							2
 #define bNetwork						3
 #define bFonts							4
 #define bFolder						5
 #define bPrefs							6
 #define bFile							7

 #define computerIcon				528


 #define offsetPerButton		60		// Number of pixels between scrollable button positions

 #define bCancel						510		// Cancel and OK buttons
 #define bOK								511



 TPPollRecord		Poll;								// Polling record to retrieve event information
 Rect						theScrollRect;			// Scrollable area
 short					theButton;					// Button number
 short					prevScrollBarValue; //	Scroll bar's value before user changed it
 short					scrolledPixels;			// Number of pixels the icons were moved
 RgnHandle			updateRgn;					// Region exposed by scrolling (ignored)
 Boolean				ExitTheDemo;				// Should the demo terminate?


 void ApplicationInitialization (void);






 //	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-
 void main(void)
 {
	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0L);


	if (!InitToolsPlus(10, 6, initTE32KBuffer, initUseColor))
		ExitToShell();

	ApplicationInitialization();

	while (!ExitTheDemo)					// Main Event Loop
		{
		if (PollSystem(&Poll))			// If an event is available, process the event
			{
			switch (Poll.What)
				{
				case doPictButton:			// Select clicked icon, deselect others
					for (theButton = bComputer; theButton <= bFile; theButton++)
						SelectPictButton(theButton, Poll.Button.Num == theButton);
					//	Your application would display the preferences on the right
					//	side of the window that correspond to the selected icon.
					break;


				case doScrollBar:				// User is scrolling the icons
					switch (Poll.ScrollBar.Part)
						{
						case inUpButton:
							SetScrollBarVal(1, GetScrollBarVal(1) - 1);	// Scroll up by 1 icon
							break;
						case inDownButton:
							SetScrollBarVal(1, GetScrollBarVal(1) + 1);	// Scroll down by 1 icon
							break;
						case inPageUp:
       				SetScrollBarVal(1, GetScrollBarVal(1) - 3);	// Scroll up by 3 icons
       				break;
       			case inPageDown:
							SetScrollBarVal(1, GetScrollBarVal(1) + 3);	// Scroll down by 3 icons
							break;
						default:
							break;
						}
					if (GetScrollBarVal(1) != prevScrollBarValue)	// If scroll bar was moved
						{
						scrolledPixels = (prevScrollBarValue - GetScrollBarVal(1)) * offsetPerButton;
						ScrollRect(&theScrollRect, 0, scrolledPixels, updateRgn);	// Shift all buttons' images inside the scrollable rect
						for (theButton = bComputer; theButton <= bFile; theButton++)
							{
							//	Shift the buttons' and panels' co-ordinates
							OffsetPictButton(theButton, 0, scrolledPixels);
							OffsetPanel(theButton, 0, scrolledPixels);
							// Hide/show the buttons and panels
							if ((theButton < GetScrollBarVal(1)) || (theButton > GetScrollBarVal(1) + 3))
								{
								// If button is above top or below bottom of list
								ObscurePictButton(theButton);
								ObscurePanel(theButton);
								}
							else
								{
								PictButtonDisplay(theButton, true);
								PanelDisplay(theButton, true);
								}
							}
							//	Remove the following line if you have set the scroll bar's speed
							//	using SetScrollBarLineTime or SetScrollBarPageTime
							Wait(6);
						prevScrollBarValue = GetScrollBarVal(1);
						}
					break;


				case doButton: 
					ExitTheDemo = true;
					break;


				default:
					break;
				}
			}
		}
	}



 //	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-
 void ApplicationInitialization (void)
 	{
 	#define		StdWindow1			1

 	#define		iconButtonSpec	picbutInstantEvent + picbutLockSelected + picbutSelectDarken + picbutDimNoChange
 	#define		labelSpec				panUseWFont + panCenterTitle

	short			theIcon;		// Icon number
	short			theButton;	// Button number
	short			vDist;			// Vertical distance from top of window

  char			iconLabel[8][12];	// label names


  strcpy(iconLabel[bComputer], "Hardware");	// Define labels for each of the icons
  strcpy(iconLabel[bDisk], 		 "Disk");
  strcpy(iconLabel[bNetwork],  "Network");
  strcpy(iconLabel[bFonts], 	 "Fonts");
  strcpy(iconLabel[bFolder],	 "Folders");
  strcpy(iconLabel[bPrefs],		 "Preferences");
  strcpy(iconLabel[bFile],		 "Files");
	updateRgn = NewRgn();

	WindowOpen(StdWindow1, 0, 0, 300, 320, "\p", dBoxProc + wCenter, NoGoAway, Modal);


	SetRect(&theScrollRect, 20, 30, 92, 270);															// Define the scrollable area
  NewPanelRect(511, &theScrollRect, "\p", panBlackBorder, 0);						// Draw frame around area
	NewScrollBar(1, 91, 30, 107, 270, scrlValueLimit, enabled, 1, 1, 4);	// Attach scroll bar
	InsetRect(&theScrollRect, 1, 1);	// Area _inside_ the frame will be scrolled later
	prevScrollBarValue = 1;						// Keep track of scroll bar's value before user changes it

	// If you have bought the Tools Plus developer kit, uncomment the
	// following line to make scroll bars scroll once every 8 ticks
  //	SetScrollBarLineTime(1, 8);
  //	SetScrollBarPageTime(1, 8);

	TextFont(geneva);	// Labels are drawn using Geneva 9pt.
	TextSize(9);

	// Create the picture buttons and the label below.
	// Only the first 4 buttons and labels are visible
	for (theButton = bComputer; theButton <= bFile; theButton++)
		{
    vDist = 40 + ((theButton - 1) * offsetPerButton);
    theIcon = computerIcon + ((theButton - 1) * 4);
    NewPictButton(theButton, 40, vDist, theIcon, iconButtonSpec + (picbutHidden * (theButton > 4)), enabled, notSelected, 0, 0, 0);
    NewPanel(theButton, 25, vDist + 39, 87, vDist + 39, C2PStr(iconLabel[theButton]), labelSpec + (panHidden * (theButton > 4)), 0);
		}

	NewButton(bCancel, 120, 285, 190, 305, "\pCancel", pushButProc, enabled, notSelected);
  NewButton(bOK, 210, 285, 280, 305, "\pOK", pushButProc + bDefault, enabled, notSelected);
  ExitTheDemo = false;
 }