{	Tools Plus Tutorial	- -	Scrolling GUI Elements	}

{	NOTE:	}
{	The MWERKS compiler directived ($IFC MWERKS) indicates code that is compiled only by	}
{	the CodeWarrior compiler.  THINK Pascal and Metrowerks CodeWarrior Pascal have	}
{	_slight_ differences, and this compiler directive lets you use one source for both compilers.	}
{	You can remove the code that does not pertain to your compiler.	}


program Tutorial;
	uses
{$IFC MWERKS}
		Dialogs, Fonts, Processes, SegLoad, TextEdit, ToolsPlus, Windows;
{$ELSEC}
		ToolsPlus;
{$ENDC}

	const
		bComputer = 1;		{picture button numbers}
		bDisk = 2;
		bNetwork = 3;
		bFonts = 4;
		bFolder = 5;
		bPrefs = 6;
		bFile = 7;

		computerIcon = 528;

		offsetPerButton = 60;	{Number of pixels between scrollable button positions}

		bCancel = 510;		{Cancel and OK buttons}
		bOK = 511;



	var
		Poll: TPPollRecord;			{Polling record to retrieve event information}
		theScrollRect: rect;			{Scrollable area}
		theButton: integer;			{Button number}

		prevScrollBarValue: integer;	{Scroll bar's value before user changed it}
		scrolledPixels: integer;			{Number of pixels the icons were moved}
		updateRgn: RgnHandle;		{Region exposed by scrolling (ignored)}

		ExitTheDemo: boolean;		{Should the demo terminate?}




{	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	}
	procedure ApplicationInitialization;
		const
			StdWindow1 = 1;

			iconButtonSpec = picbutInstantEvent + picbutLockSelected + picbutSelectDarken + picbutDimNoChange;
			labelSpec = panUseWFont + panCenterTitle;

		var
			theIcon: integer;		{Icon number}
			theButton: integer;	{Button number}
			vDist: integer;		{Vertical distance from top of window}

			iconLabel: array[bComputer..bFile] of string[12];	{label names}
	begin
		iconLabel[bComputer] := 'Hardware';	{Define labels for each of the icons}
		iconLabel[bDisk] := 'Disk';
		iconLabel[bNetwork] := 'Network';
		iconLabel[bFonts] := 'Fonts';
		iconLabel[bFolder] := 'Folders';
		iconLabel[bPrefs] := 'Preferences';
		iconLabel[bFile] := 'Files';
		updateRgn := NewRgn;

		WindowOpen(StdWindow1, 0, 0, 300, 320, '', dBoxProc + wCenter, noGoAway, Modal);


		SetRect(theScrollRect, 20, 30, 92, 270);							{Define the scrollable area}
		NewPanelRect(511, theScrollRect, '', panBlackBorder, 0);			{Draw frame around area}
		NewScrollBar(1, 91, 30, 107, 270, scrlValueLimit, enabled, 1, 1, 4);	{Attach scroll bar}
		InsetRect(theScrollRect, 1, 1);										{Area _inside_ the frame will be scrolled later}
		prevScrollBarValue := 1;	{Keep track of scroll bar's value before user changes it}

	{If you have bought the Tools Plus developer kit, uncomment the	}
	{	following line to make scroll bars scroll once every 8 ticks		}
	{    SetScrollBarLineTime(1, 8);	}
	{    SetScrollBarPageTime(1, 8);	}

		TextFont(geneva);		{Labels are drawn using Geneva 9pt. }
		TextSize(9);

	{	Create the picture buttons and the label below.  Only the first 4 buttons and labels are visible	}
		for theButton := bComputer to bFile do
			begin
				vDist := 40 + ((theButton - 1) * offsetPerButton);
				theIcon := computerIcon + ((theButton - 1) * 4);
				NewPictButton(theButton, 40, vDist, theIcon, iconButtonSpec + (picbutHidden * ord(theButton > 4)), enabled, notSelected, 0, 0, 0);
				NewPanel(theButton, 25, vDist + 39, 87, vDist + 39, iconLabel[theButton], labelSpec + (panHidden * ord(theButton > 4)), 0);
			end;


		NewButton(bCancel, 120, 285, 190, 305, 'Cancel', pushButProc, enabled, notSelected);
		NewButton(bOK, 210, 285, 280, 305, 'OK', pushButProc + bDefault, enabled, notSelected);
		ExitTheDemo := false;
	end;




{	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	}
begin
{$IFC MWERKS}
{Toolbox initialization - - Done automatically by THINK Pascal}
	InitGraf(@qd.thePort);
	InitFonts;
	InitWindows;
	InitMenus;
	TEInit;
	InitDialogs(nil);
{$ENDC}

	if not InitToolsPlus(10, 1, initTE32KBuffer, initUseColor) then
		ExitToShell;

	ApplicationInitialization;

	while not ExitTheDemo do	{Main Event Loop}
		if PollSystem(Poll) then	{If an event is available, process the event}

			case Poll.What of

				doPictButton:	{Select clicked icon, deselect others}
					for theButton := bComputer to bFile do
						SelectPictButton(theButton, Poll.Button.Num = theButton);
			{	Your application would display the preferences on the right	}
			{	side of the window that correspond to the selected icon.	}



				doScrollBar:	{User is scrolling the icons}
					begin
						case Poll.ScrollBar.Part of
							inUpButton: 
								SetScrollBarVal(1, GetScrollBarVal(1) - 1);	{Scroll up by 1 icon}
							inDownButton: 
								SetScrollBarVal(1, GetScrollBarVal(1) + 1);	{Scroll down by 1 icon}
							inPageUp: 
								SetScrollBarVal(1, GetScrollBarVal(1) - 3);	{Scroll up by 3 icons}
							inPageDown: 
								SetScrollBarVal(1, GetScrollBarVal(1) + 3);	{Scroll down by 3 icons}
							otherwise
						end;

						if GetScrollBarVal(1) <> prevScrollBarValue then	{If scroll bar was moved}
							begin
								scrolledPixels := (prevScrollBarValue - GetScrollBarVal(1)) * offsetPerButton;
								ScrollRect(theScrollRect, 0, scrolledPixels, updateRgn);	{Shift all buttons' images inside the scrollable rect}
								for theButton := bComputer to bFile do
									begin
					{	Shift the buttons' and panels' co-ordinates	}
										OffsetPictButton(theButton, 0, scrolledPixels);
										OffsetPanel(theButton, 0, scrolledPixels);
					{	Hide/show the buttons and panels	}
										if (theButton < GetScrollBarVal(1)) or (theButton > GetScrollBarVal(1) + 3) then
											begin	{If button is above top or below bottom of list	}
												ObscurePictButton(theButton);
												ObscurePanel(theButton);
											end
										else
											begin
												PictButtonDisplay(theButton, true);
												PanelDisplay(theButton, true);
											end
									end;

				{Remove the following line if you have set the scroll bar's speed	}
				{	using SetScrollBarLineTime or SetScrollBarPageTime		}
								Wait(6);
								prevScrollBarValue := GetScrollBarVal(1);
							end
					end;



				doButton: 
					ExitTheDemo := true;

				otherwise	{All other events are ignored}
			end
end.