//	Tools Plus Tutorial	- -	Scrolling a field list



 #include "string.h"
 #include "ToolsPlus.h"



 #define fieldHeight				12		// Field's height
 #define offsetPerRow				13		// Number of pixels eash row is offset
		
 #define bCancel						510		// Cancel and OK buttons
 #define bOK								511




 TPPollRecord		Poll;								// Polling record to retrieve event information
 Rect						theScrollRect;			// Scrollable area
 short					theRow;							// Row number
 short					theColumn;					// Column number
 short					fieldNumber;				// Calculated field number
 
 Handle					fieldStr[101][5];		// Contents of each field

 short					prevScrollBarValue;	// Scroll bar's value before & after user changed it}
 short					newScrollBarValue;

 RgnHandle			updateRgn;					// Region exposed by scrolling (ignored)
 Boolean				ExitTheDemo;				// Should the demo terminate?




 void ApplicationInitialization (void);
 void ScrollTheGrid (void);
 void DrawGridLines (void);




 //	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-
 void main(void)
 {
	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0L);


	if (!InitToolsPlus(10, 1, initTE32KBuffer, initUseColor))
		ExitToShell();

	ApplicationInitialization();

	while (!ExitTheDemo)					// Main Event Loop
		{
		if (PollSystem(&Poll))			// If an event is available, process the event
			{
			switch (Poll.What)
				{

				case doScrollBar:				// User is scrolling the list
					switch (Poll.ScrollBar.Part)
						{
						case inUpButton:
							SetScrollBarVal(1, prevScrollBarValue - 1);	// Scroll up by 1 line
							break;
						case inDownButton:
							SetScrollBarVal(1, prevScrollBarValue + 1);	// Scroll down by 1 line
							break;
						case inPageUp:
							SetScrollBarVal(1, prevScrollBarValue - 9);	// Scroll up by 9 lines
       				break;
       			case inPageDown:
							SetScrollBarVal(1, prevScrollBarValue + 9);	// Scroll down by 9 lines
							break;
						default:
							break;
						}
						newScrollBarValue = GetScrollBarVal(1);
						if (newScrollBarValue != prevScrollBarValue)	//	If scroll bar was moved
							ScrollTheGrid();
					break;


				case doKeyDown: case doAutoKey: 
					if (HaveTabInField())
						{
						newScrollBarValue = GetScrollBarVal(1);
						SaveFieldString();
						if (Poll.Modifiers.Bits.ShiftKey)	// Tab to PREVIOUS field
							{
							if (ActiveFieldNumber() > newScrollBarValue * 10 + 1)		// Not the first visible field?
								TabToField();
							else if (newScrollBarValue == GetScrollBarMin(1))				// 1st first in list
								{
								// When you shift-tab from the first field, we loop
								// around the list to select the last field on the list
								newScrollBarValue = GetScrollBarMax(1);
								SetScrollBarVal(1, newScrollBarValue);
								ScrollTheGrid();
								ActivateField(1004, teSelectDefault);		// Activate the last field in the list
								}
							else
								{		// Top visible field and list can be scrolled
								newScrollBarValue = newScrollBarValue - 1;	// Scroll up by 1 line
								SetScrollBarVal(1, newScrollBarValue);
								ScrollTheGrid();
								TabToField();
								}
							}
						else	// Tab to NEXT field
							{
							if (ActiveFieldNumber() < (newScrollBarValue + 9) * 10 + 4)		// Not the last visible field?
								TabToField();
							else
								{
								if (newScrollBarValue == GetScrollBarMax(1))		// Last field in list
									{
									// When you tab from the last field, we loop around
									// the list to select the first field on the list
									newScrollBarValue = GetScrollBarMin(1);
									SetScrollBarVal(1, newScrollBarValue);
									ScrollTheGrid();
									ActivateField(11, teSelectDefault);	// Activate first field in the list
									}
								else
									{
									newScrollBarValue = newScrollBarValue + 1;	// Scroll down by 1 line
									SetScrollBarVal(1, newScrollBarValue);
									ScrollTheGrid();
									TabToField();
									}
								}
							}
						}
					break;


				case doClickField: 
					SaveFieldString();
					ClickInField();
					break;


				case doRefresh: 
					DrawGridLines();


				case doButton: 
					ExitTheDemo = true;


				case doMenu: 
					ExitTheDemo = true;

				default:	// All other events are ignored
					break;
				}
			}
		}
	}



 //	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-
 void ApplicationInitialization (void)
 	{
 	#define		StdWindow1			1

	short			theRow;						// Row number
	short			theColumn;				// Column number
	
	Str255		rowStr, colStr;		// Row number and column number, expressed as a string
	char			theFieldStr[10];	// Field's contents (initial value)	


	AppleMenu("\p");
	Menu(mFileMenu, 0, enabled, "\pFile");
	Menu(mFileMenu, 1, enabled, "\pQuit/Q");
	Menu(mEditMenu, 0, enabled, "\pEdit");
	Menu(mEditMenu, 1, disabled, "\pUndo/Z");
	Menu(mEditMenu, 2, disabled, mDividingLine);
	Menu(mEditMenu, 3, disabled, "\pCut/X");
	Menu(mEditMenu, 4, disabled, "\pCopy/C");
	Menu(mEditMenu, 5, disabled, "\pPaste/V");
	Menu(mEditMenu, 6, disabled, "\pClear");
	Menu(mEditMenu, 7, disabled, mDividingLine);
	Menu(mEditMenu, 8, disabled, "\pSelect All/A");
	SetSelectAllItem(8);


	WindowOpen(StdWindow1, 0, 0, 396, 205, "\pScrolling a Field List", noGrowDocProc + wCenter, NoGoAway, NotModal);


	SetRect(&theScrollRect, 20, 19, 361, 150);												// Define the scrollable area
	NewPanelRect(511, &theScrollRect, "\p", panBlackBorder, 0);				// Draw frame around area
	NewScrollBar(1, 360, 19, 376, 150, scrlValueLimit, enabled, 1, 1, 91);	// Attach scroll bar
	InsetRect(&theScrollRect, 1, 1);	// Area _inside_ the frame will be scrolled later

	NewButton(bCancel, 120, 170, 190, 190, "\pCancel", pushButProc, enabled, notSelected);
	NewButton(bOK, 210, 170, 280, 190, "\pOK", pushButProc + bDefault, enabled, notSelected);


	// Allocate the string handles for all the fields in the grid. Populate each one of the
	// fields with an initial value in R1:C1 format. Each handle is only as big as it needs
	// to be to store the current contents
	for (theRow = 1; theRow <= 100; theRow++)
		for (theColumn = 1; theColumn <= 4; theColumn++)
			{
			NumToString(theRow, rowStr);
			NumToString(theColumn, colStr);
			strcpy(theFieldStr, "R");
			strcat(theFieldStr, P2CStr(rowStr));
			strcat(theFieldStr, ":C");
			strcat(theFieldStr, P2CStr(colStr));
			fieldStr[theRow][theColumn] = (Handle)NewStrHandle(strlen(theFieldStr));
			BlockMove(theFieldStr, *(fieldStr[theRow][theColumn]), strlen(theFieldStr) + 1);
			}


	// Make the "scroll to view" routine think that the required fields are out of view.
	// It will then create the fields to match the scroll bar's current position
		prevScrollBarValue = 11;
		newScrollBarValue = 1;
		ScrollTheGrid();


		updateRgn = NewRgn();
		ExitTheDemo = false;
 }



 //	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-
 void ScrollTheGrid (void)
	{
	short			vDist;						// Vertical distance from top of window

	short			theRow;						// Row number
	short			theColumn;				// Column number

	short			scrolledRows;			// Number of rows scrolled
	short			scrolledPixels;		// Number of pixels the icons were moved

	short			startRow, endRow;	// First and last row being processed
	
	

	// Scroll the IMAGE of the fields and redraw the grid
	scrolledRows = prevScrollBarValue - newScrollBarValue;
	scrolledPixels = scrolledRows * offsetPerRow;
	ScrollRect(&theScrollRect, 0, scrolledPixels, updateRgn);
	DrawGridLines();



	// #1: Delete obsolete fields (their data is still in the array of handles)
	if (scrolledRows < 0)		// Scroll Up: Delete lines scrolled off the top of the list
		{
		startRow = prevScrollBarValue;
		endRow = min(prevScrollBarValue + 9, newScrollBarValue - 1);
		}
	else		// Scroll Down: Delete lines scrolled off the bottom of the list
		{
		startRow = max(newScrollBarValue + 10, prevScrollBarValue);
		endRow = prevScrollBarValue + 9;
		}
	for (theRow = startRow; theRow <= endRow; theRow++)
		for (theColumn = 1; theColumn <= 4; theColumn++)
			KillField(theRow * 10 + theColumn);



	// #2: Shift co-ordinates for the remaining fields
	for (theRow = prevScrollBarValue; theRow <= prevScrollBarValue + 9; theRow++)
		for (theColumn = 1; theColumn <= 4; theColumn++)
			OffsetField(theRow * 10 + theColumn, 0, scrolledPixels);



	// #3: Create new fields that are now appearing in the grid
	if (scrolledRows < 0)		// Scroll Up: Add fields to the bottom of the list
		{
		startRow = newScrollBarValue + 10 - min(-scrolledRows, 10);
		endRow = newScrollBarValue + 9;
		}
	else		// Scroll Down: Add fields to the top of the list
		{
		startRow = newScrollBarValue;
		endRow = startRow + min(scrolledRows, 10) - 1;
		}
	TextFont(geneva);		// Fields are drawn using Geneva 9pt.
	TextSize(9);
	for (theRow = startRow; theRow <= endRow; theRow++)
		{
		vDist = 20 + ((theRow - newScrollBarValue) * offsetPerRow);
		fieldNumber = theRow * 10;

		// Our fields automatically shrink the handle down to match the amount of text
		// in the field.  Before we hand the handle to the field, we blow it up to the
		// maxium size (255 chars plus length byte or null terminator). The field then
		// knows that the handle's _maximum_ size.
		for (theColumn = 1; theColumn <= 4; theColumn++)
			SetHandleSize(fieldStr[theRow][theColumn], 256);

		// Create the 4 columns in this row (4 fields)
		NewField(fieldNumber + 1, 23, vDist, 68, vDist + fieldHeight, fieldStr[theRow][1], teNoBoxNoCR + teResizeHdl + teCstring, teJustLeft);
		NewField(fieldNumber + 2, 73, vDist, 148, vDist + fieldHeight, fieldStr[theRow][2], teNoBoxNoCR + teResizeHdl + teCstring, teJustLeft);
		NewField(fieldNumber + 3, 153, vDist, 298, vDist + fieldHeight, fieldStr[theRow][3], teNoBoxNoCR + teResizeHdl + teCstring, teJustLeft);
		NewField(fieldNumber + 4, 303, vDist, 357, vDist + fieldHeight, fieldStr[theRow][4], teNoBoxNoCR + teResizeHdl + teCstring, teJustLeft);
		}



		prevScrollBarValue = newScrollBarValue;
	}
	


 //	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-
 void DrawGridLines (void)
	{
	RGBColor	lineColor;
	short			theRow;


	// These "color" routines are safe on Macs without Color QuickDraw
	SetRGB(&lineColor, 32896, 32896, 32896);
	SetFrontRGB(&lineColor);

	MoveTo(70, 20);	// Draw the 3 vertical lines
	LineTo(70, 148);
	MoveTo(150, 20);
	LineTo(150, 148);
	MoveTo(300, 20);
	LineTo(300, 148);

	// Draw a horizontal line beneath each row except the bottom one
	for (theRow = 1; theRow <= 9; theRow++)
		{
		MoveTo(21, 19 + (theRow * offsetPerRow));
		Line(338, 0);
		}
	}