{	Tools Plus Tutorial	- -	Tabs & Multiple Layers	}

{	NOTE:	}
{	The MWERKS compiler directived ($IFC MWERKS) indicates code that is compiled only by	}
{	the CodeWarrior compiler.  THINK Pascal and Metrowerks CodeWarrior Pascal have	}
{	_slight_ differences, and this compiler directive lets you use one source for both compilers.	}
{	You can remove the code that does not pertain to your compiler.	}


{	IMPORTANT:	}
{	This tutorial required a Tab CDEF.  You can get CDEFs from third parties (Jim's CDEFs are	}
{	available for free on the Internet and various BBSs).  Water's Edge Software also offers a	}
{	collection of world class, professionally designed and coded CDEFs aptly named			}
{	'Super CDEFs'.  They include a variety of flat and 3D buttons, tabs, sliders and thermometer.}
{		Whether you want a minor enhancement while retaining much of Apple's existing			}
{	appearance, or if you want a complete "3D look" user interface like those seen in today's	}
{	state-of-the-art applications, Super CDEFs is the finishing touch for all your projects.		}


program Tutorial;
	uses
{$IFC MWERKS}
		Dialogs, Fonts, Processes, SegLoad, TextEdit, ToolsPlus, Windows;
{$ELSEC}
		ToolsPlus;
{$ENDC}

	const
		StdWindow1 = 1;

		bListsTab = 500;
		bButtonsTab = 501;

		leftList = 2;		{"Lists" layout}
		rightList = 3;

		radioButtonPanel = 4;	{"Buttons" layout	}
		bAllright = 10;
		bNotTooBad = 11;
		bPrettyGood = 12;
		bImpressive = 13;
		bRockin = 14;

		bCancel = 510;		{Cancel and OK buttons}
		bOK = 511;



	var
		Poll: TPPollRecord;			{Polling record to retrieve event information}

		windowRect: rect;			{Window's co-ordinates}
		theButton: integer;			{Button counter}

		ExitTheDemo: boolean;		{Should the demo terminate?}







{	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	}
	procedure ApplicationInitialization;
		const
			tabProc = 32000 + bCDEFRadioButton;

		var
			lightGray, mediumGray, darkGray, black, white: RGBColor;
			theRect: rect;


	begin
		AppleMenu('');
		Menu(mFileMenu, 0, enabled, 'File');
		Menu(mFileMenu, 1, enabled, 'Quit/Q');
		Menu(mEditMenu, 0, enabled, 'Edit');
		Menu(mEditMenu, 1, disabled, 'Undo/Z');
		Menu(mEditMenu, 2, disabled, mDividingLine);
		Menu(mEditMenu, 3, disabled, 'Cut/X');
		Menu(mEditMenu, 4, disabled, 'Copy/C');
		Menu(mEditMenu, 5, disabled, 'Paste/V');
		Menu(mEditMenu, 6, disabled, 'Clear');
		Menu(mEditMenu, 7, disabled, mDividingLine);
		Menu(mEditMenu, 8, disabled, 'Select All/A');
		SetSelectAllItem(8);

		SetRGB(lightGray, 61166, 61166, 61166);
		SetRGB(mediumGray, 52428, 52428, 52428);
		SetRGB(black, 0, 0, 0);
		SetRGB(white, 65535, 65535, 65535);
		SetRGB(darkGray, 30583, 30583, 30583);


	{	Create a hidden window (looks faster when you don't see it being built)	}
		SetRect(windowRect, 0, 0, 400, 205);
		WindowOpenRect(StdWindow1, windowRect, 'Tabs (the control, not the field thing)', noGrowDocProc + wCenter + wHidden, noGoAway, notModal);
		SetBackdropColor(StdWindow1, lightGray);


	{	Create panel outlining the are that will change	}
		NewPanel(1, 10, 25, 390, 155, '', panCustomColors + panRaiseShadow + panFillBack + panOutlined + panBlackBorder + panRoundCorner7, 1);

	{	Create tabs at the top of the panel	}
		ButtonColors(black, mediumGray, black, mediumGray);
		NewButton(bListsTab, 14, 8, 84, 27, 'Lists', tabProc + bColorButton, enabled, selected);
		NewButton(bButtonsTab, 83, 8, 153, 27, 'Buttons', tabProc + bColorButton, enabled, notSelected);


	{	Create and populate the list boxes in layer 1	}
		TextFont(geneva);
		TextSize(9);
		NewListBox(leftList, 40, 45, 170, 129, lOnlyOne);
		SetListBoxText(leftList, 1, 'T+ for Symantec C/C++');
		SetListBoxText(leftList, 2, 'T+ for THINK Pascal');
		SetListBoxText(leftList, 3, 'T+ for CodeWarrior C/C++');
		SetListBoxText(leftList, 4, 'T+ for CodeWarrior Pascal');
		SetListBoxText(leftList, 5, 'All 680x0');
		SetListBoxText(leftList, 6, 'All PowerMac');
		SetListBoxText(leftList, 7, '680x0 and PowerMac');
		SetListBoxLine(leftList, 7, on);
		NewPanel(leftList, 38, 43, 187, 131, '', panCustomColors + panInsetShadow, 1);

		NewListBox(rightList, 220, 45, 350, 129, lOnlyOne);
		SetListBoxText(rightList, 1, 'Libraries & Headers');
		SetListBoxText(rightList, 2, 'Demo application');
		SetListBoxText(rightList, 3, 'Tutorials');
		SetListBoxText(rightList, 4, 'Custom CDEFs');
		SetListBoxLine(rightList, 1, on);
		NewPanel(rightList, 218, 43, 367, 131, '', panCustomColors + panInsetShadow, 1);


	{	Create radio button group for layer 2 (all hidden)	}
		NewPanel(radioButtonPanel, 35, 40, 145, 135, 'Grade:', panLeftTitle + panInsetShadow + panBWGrayBorder + panAutoDeselect + panCustomColors + panHidden, 1);
		NewButton(bAllright, 40, 50, 110, 66, 'Alright', radioButProc + bColorButton + bHidden, enabled, notSelected);
		NewButton(bNotTooBad, 40, 66, 140, 82, 'Not too bad', radioButProc + bColorButton + bHidden, enabled, notSelected);
		NewButton(bPrettyGood, 40, 82, 140, 98, 'Pretty good', radioButProc + bColorButton + bHidden, enabled, notSelected);
		NewButton(bImpressive, 40, 98, 135, 114, 'Impressive', radioButProc + bColorButton + bHidden, enabled, notSelected);
		NewButton(bRockin, 40, 114, 110, 130, 'Rockin', radioButProc + bColorButton + bHidden, enabled, selected);


	{	Cancel and OK buttons	}
		NewButton(bCancel, 120, 170, 190, 190, 'Cancel', pushButProc, enabled, notSelected);
		NewButton(bOK, 210, 170, 280, 190, 'OK', pushButProc + bDefault, enabled, notSelected);

		WindowDisplay(StdWindow1, on);	{Unhide window.  Everything is displayed quickly.	}
		ExitTheDemo := false;
	end;



{	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	}
	procedure DisplayLayer (ShowIt: boolean);
		var
			theButton: integer;

			showButtonLayout: boolean;
			showListLayout: boolean;
	begin
		showListLayout := ((Poll.Button.Num = bListsTab) and ShowIt);
		PanelDisplay(leftList, showListLayout);
		ListBoxDisplay(leftList, showListLayout);
		PanelDisplay(rightList, showListLayout);
		ListBoxDisplay(rightList, showListLayout);

		showButtonLayout := ((Poll.Button.Num = bButtonsTab) and ShowIt);
		PanelDisplay(radioButtonPanel, showButtonLayout);
		for theButton := bAllright to bRockin do
			ButtonDisplay(theButton, showButtonLayout);
	end;



{	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	}
begin
{$IFC MWERKS}
{Toolbox initialization - - Done automatically by THINK Pascal}
	InitGraf(@qd.thePort);
	InitFonts;
	InitWindows;
	InitMenus;
	TEInit;
	InitDialogs(nil);
{$ENDC}

	if not InitToolsPlus(10, 1, initTE32KBuffer, initUseColor) then
		ExitToShell;

	ApplicationInitialization;

	while not ExitTheDemo do	{Main Event Loop}
		if PollSystem(Poll) then	{If an event is available, process the event}
			case Poll.What of


				doButton: 
					case Poll.Button.Num of

						bListsTab, bButtonsTab:	{Switching layouts	}
							if not ButtonIsSelected(Poll.Button.Num) then
								begin
									for theButton := bListsTab to bButtonsTab do
										SelectButton(theButton, theButton = Poll.Button.Num);

									DisplayLayer(off);		{Hide all layouts	}

									RefreshToolsPlusInWindow(StdWindow1);	{Redraw T+ GUI elements}
									ValidRect(windowRect);	{Validate window to prevent flickering from a subsequent refresh}

									DisplayLayer(on);		{Show newly selected layout}
								end;


						bAllright..bRockin: 
							SelectButton(Poll.Button.Num, selected);


						bCancel, bOK: 
							ExitTheDemo := true;
					end;


				doMenu: 
					ExitTheDemo := true;

				otherwise	{All other events are ignored}

			end
end.